<Serializable()> _
Public Class ParameterCollection
    Inherits CollectionBase

    Default Public Property Item(ByVal index As Integer) As Parameter
        Get
            Return CType(List(index), Parameter)
        End Get
        Set(ByVal Value As Parameter)
            List(index) = Value
        End Set
    End Property

    Public Function Add(ByVal value As Parameter) As Integer
        Return List.Add(value)
    End Function

    Public Sub SetItems(ByVal items As Object())
        Clear()
        For Each obj As Object In items
            List.Add(obj)
        Next
    End Sub

    Public Function ToParameterArray() As Parameter()
        Dim a(Count - 1) As Parameter
        list.CopyTo(a, 0)
        Return a
    End Function
End Class

<Serializable()> _
Public Class FilterCollection
    Inherits CollectionBase

    Default Public Property Item(ByVal index As Integer) As Filter
        Get
            Return CType(List(index), Filter)
        End Get
        Set(ByVal Value As Filter)
            List(index) = Value
        End Set
    End Property

    Public Function Add(ByVal value As Filter) As Integer
        Return List.Add(value)
    End Function

    Public Sub SetItems(ByVal items As Object())
        Clear()
        For Each obj As Object In items
            List.Add(obj)
        Next
    End Sub

    Public Function ToArray() As Object()
        Dim a(Count - 1) As Object
        list.CopyTo(a, 0)
        Return a
    End Function

    Public Function GetFilter(ByVal name As String) As Filter
        For i As Integer = 0 To Count - 1
            If Me(i).Name.ToLower = name.ToLower Then
                Return CType(List(i), Filter)
            End If
        Next
    End Function

    Public Function IndexOf(ByVal f As Filter) As Integer
        Return list.IndexOf(f)
    End Function
End Class