Imports System
Imports System.Collections
Imports System.ComponentModel
Imports System.ComponentModel.Design
Imports System.Drawing
Imports System.Drawing.Design
Imports System.Data
Imports System.Windows.Forms
Imports System.Windows.Forms.Design

<Designer(GetType(GroupBoxControl.GroupBoxControlDesigner))> _
Public Class GroupBoxControl
    Inherits System.Windows.Forms.UserControl
    Private components As System.ComponentModel.Container = Nothing

    Public Sub New()
        InitializeComponent()
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not components Is Nothing Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    Private Sub InitializeComponent()
        Me.Name = "GroupBoxControl"
        Me.Size = New System.Drawing.Size(152, 150)
    End Sub
    Private mActiveContainerGroupBox As ContainerGroupBox

    <Description("The active ContainerGroupBox"), Category("_ Properties")> _
    Public Property ActiveContainerGroupBox() As ContainerGroupBox
        Get
            Return mActiveContainerGroupBox
        End Get
        Set(ByVal Value As ContainerGroupBox)
            If Not (Value Is Nothing) Then
                If Not DesignMode Then
                    For Each c As Control In Me.Controls
                        c.Visible = False
                    Next
                End If
                mActiveContainerGroupBox = Value
                mActiveContainerGroupBox.Visible = True
                mActiveContainerGroupBox.BringToFront()
            End If
        End Set
    End Property

    Public Class GroupBoxControlDesigner
        Inherits ControlDesigner
        Private mDesignerHost As IDesignerHost
        Private mVerbs As DesignerVerbCollection
        Private mGroupBoxControl As GroupBoxControl

        Sub New()
            mVerbs = New DesignerVerbCollection
            mVerbs.Add(New DesignerVerb("Add ContainerGroupBox", AddressOf OnAddItem))
        End Sub

        Function GetNewItemName() As String
            Dim num As Integer = 1
            Dim duplicate As Boolean
            Dim svc As IReferenceService = CType(GetType(IReferenceService), IReferenceService)
            Dim name As String
            Do
                name = "containerGroupBox" + num.ToString
                duplicate = (Not (svc.GetReference(name) Is Nothing))
                num += 1
            Loop While duplicate
            Return name
        End Function

        Public Sub OnAddItem(ByVal sender As Object, ByVal e As EventArgs)
            Dim name As String = GetNewItemName()
            Dim gb As ContainerGroupBox = CType(mDesignerHost.CreateComponent(GetType(ContainerGroupBox), name), ContainerGroupBox)
            gb.FlatStyle = FlatStyle.System
            gb.Dock = DockStyle.Fill
            mGroupBoxControl.Controls.Add(gb)
            mGroupBoxControl.ActiveContainerGroupBox = gb
        End Sub

        Public Overloads Overrides Sub Initialize(ByVal component As IComponent)
            MyBase.Initialize(component)
            If TypeOf Control Is GroupBoxControl Then
                mGroupBoxControl = CType(Control, GroupBoxControl)
                mDesignerHost = CType(GetService(GetType(IDesignerHost)), IDesignerHost)
            End If
        End Sub

        Public Overloads Overrides ReadOnly Property Verbs() As DesignerVerbCollection
            Get
                Return mVerbs
            End Get
        End Property
    End Class

    Public Class ContainerGroupBox
        Inherits GroupBox

        Public Sub New()
            Visible = DesignMode
        End Sub
    End Class
End Class

