Public Class Dir
    Public Shared Function TrimBackslash(ByVal path As String) As String
        If path = "" OrElse path Is Nothing Then
            Return ""
        End If
        If path.EndsWith("\") AndAlso Not path.EndsWith(":\") Then
            Return path.TrimEnd("\"c)
        End If
        Return path
    End Function

    Public Shared Function Backslash(ByVal path As String) As String
        If path = "" OrElse path Is Nothing Then
            Return ""
        End If
        If path.EndsWith("\") Then Return path
        Return path + "\"
    End Function

    Public Shared Function GetFilePaths(ByVal directory As String, ByVal searchPattern As String) As String()
        Dim fi As IO.FileInfo
        Dim sc As New ExtendedStringCollection
        For Each fi In GetFiles(directory, searchPattern)
            sc.Add(fi.FullName)
        Next
        Dim sa As String() = sc.ToStringArray()
        Array.Sort(sa)
        Return sa
    End Function

    Public Shared Function GetFilePaths(ByVal directory As String) As String()
        Return GetFilePaths(directory, "*.*")
    End Function

    Public Shared Function GetFiles(ByVal folder As String, ByVal searchPattern As String) As IO.FileInfo()
        Try
            Return New IO.DirectoryInfo(folder).GetFiles(searchPattern)
        Catch
            Return New IO.FileInfo() {}
        End Try
    End Function

    Public Shared Function Exists(ByVal path As String) As Boolean
        Return IO.Directory.Exists(path)
    End Function

    Public Shared Function GetFilePathsWithSubDirs(ByVal startDir As String) As String()
        Dim filePaths As New ExtendedStringCollection
        AddFiles(startDir, filePaths)
        Return filePaths.ToStringArray
    End Function

    Private Shared Sub AddFiles(ByVal startDir As String, ByVal filePaths As ExtendedStringCollection)
        If Dir.Exists(startDir) Then
            Dim di As New IO.DirectoryInfo(startDir)
            Dim fsi As IO.FileSystemInfo

            For Each fsi In di.GetFileSystemInfos()
                If TypeOf fsi Is IO.FileInfo Then
                    filePaths.Add(fsi.FullName)
                Else
                    AddFiles(fsi.FullName, filePaths)
                End If
            Next
        End If
    End Sub
End Class