Imports System.IO

Public Class File
    Private mPath As String

    Public Shared Sub Delete(ByVal path As String)
        Try
            IO.File.Delete(path)
        Catch ex As Exception
        End Try
    End Sub

    Public Shared Function Exists(ByVal path As String) As Boolean
        Return IO.File.Exists(path)
    End Function

    Public Shared Function GetBaseExtension(ByVal path As String) As String
        Return GetBase(path) + GetExtension(path)
    End Function

    Public Shared Function GetBase(ByVal path As String) As String
        Dim base As String = Str.GetRightLast(path, "\")
        Return Str.GetLeftLast(base, ".")
    End Function

    Public Shared Function GetDir(ByVal path As String) As String
        If Not Str.Contains(path, "\") Then Return ""
        Return Str.GetLeft(path, path.LastIndexOf("\") + 1)
    End Function

    Public Shared Function GetDirBase(ByVal path As String) As String
        Return GetDir(path) + GetBase(path)
    End Function

    Public Shared Function GetExtension(ByVal path As String) As String
        Dim extension As String = Str.GetRightLast(path, ".")
        If extension <> "" Then
            Return "." + extension
        Else
            Return ""
        End If
    End Function
End Class