Imports System.Globalization
Imports System.Runtime.InteropServices

Public Class RichTextBoxHelper
    Public Shared Sub SetSelectedText(ByVal rtb As RichTextBox, ByVal text As String)
        Dim selectionStart As Integer = rtb.SelectionStart
        rtb.SelectedText = text
        rtb.SelectionStart = selectionStart
        rtb.SelectionLength = text.Length
    End Sub

    Public Shared Sub DisableAutoSelection(ByVal rtb As RichTextBox)
        WinAPI.User32.SendMessage(rtb.Handle, &H400 + 77, &H4, &H1)
    End Sub
End Class

Public Class ClipboardHelper
    Public Shared Sub SetString(ByVal value As String)
        Clipboard.SetDataObject(value)
    End Sub

    Public Shared Function GetString() As String
        Return CStr(Clipboard.GetDataObject.GetData(GetType(System.String)))
    End Function
End Class

Public Class XMLNodeHelper
    Public Shared Function GetStringAttribute(ByVal node As Xml.XmlNode, ByVal name As String) As String
        Dim attribute As Xml.XmlAttribute = node.Attributes.ItemOf(name)
        If Not attribute Is Nothing Then
            Return attribute.Value()
        End If
        Return ""
    End Function

    Public Shared Function GetBooleanAttribute(ByVal node As Xml.XmlNode, ByVal name As String) As Boolean
        Dim attribute As Xml.XmlAttribute = node.Attributes.ItemOf(name)
        If Not attribute Is Nothing Then
            Return attribute.Value().ToLower = "true"
        End If
    End Function
End Class

Public Class DoubleHelper
    Public Shared Function GetDouble(ByVal value As String) As Double
        If value.IndexOf(",") > -1 AndAlso _
            NumberFormatInfo.CurrentInfo.NumberDecimalSeparator = "." Then
            value = value.Replace(",", ".")
        ElseIf value.IndexOf(".") > -1 AndAlso _
            NumberFormatInfo.CurrentInfo.NumberDecimalSeparator = "," Then
            value = value.Replace(".", ",")
        End If
        Return Convert.ToDouble(value)
    End Function
End Class