Imports System.IO

Public Class Str
    Private _text As String = ""

    Public Sub New()
    End Sub

    Public Sub New(ByVal value As String)
        _text = value
    End Sub

    Public Shared Function GetRightLast(ByVal value As String, ByVal start As String) As String
        If Not Contains(value, start) Then Return ""
        Return value.Substring(value.LastIndexOf(start) + start.Length)
    End Function

    Public Shared Function Contains(ByVal value As String, ByVal search As String) As Boolean
        If value = "" Or search = "" Or value Is Nothing Or search Is Nothing Then
            Return False
        End If
        Return value.IndexOf(search) > -1
    End Function

    Public Shared Function GetLeft(ByVal value As String, ByVal index As Integer) As String
        If value Is Nothing Then value = ""
        If index < 0 Then Return ""
        If index > value.Length Then Return value
        Return value.Substring(0, index)
    End Function

    Public Shared Function GetLeftLast(ByVal value As String, ByVal start As String) As String
        If Not Contains(value, start) Then Return ""
        Return value.Substring(0, value.LastIndexOf(start))
    End Function

    Public Sub Add(ByVal value As String)
        _text += value + vbCrLf
    End Sub

    Public Sub Save(ByVal path As String)
        Save(path, System.Text.Encoding.Default)
    End Sub

    Public Sub Save(ByVal path As String, ByVal encoding As System.Text.Encoding)
        Try
            Dim sw As New IO.StreamWriter(IO.File.Create(path), encoding)
            sw.Write(_text)
            sw.Close()
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Sub

    Public Sub AddFile(ByVal path As String, ByVal encoding As System.Text.Encoding)
        If File.Exists(path) Then
            Dim sr As New IO.StreamReader(IO.File.OpenRead(path), encoding)
            Add(sr.ReadToEnd())
            sr.Close()
        End If
    End Sub

    Public Sub AddFile(ByVal path As String)
        AddFile(path, System.Text.Encoding.Default)
    End Sub

    Public ReadOnly Property Lines() As String()
        Get
            Return Split(_text, vbCrLf)
        End Get
    End Property

    Public Shared Function GetLeft(ByVal value As String, ByVal start As String) As String
        If Not Contains(value, start) Then
            Return ""
        End If
        Return value.Substring(0, value.IndexOf(start))
    End Function

    Public Shared Function GetRight(ByVal value As String, ByVal start As String) As String
        If Not Contains(value, start) Then
            Return ""
        End If
        Return value.Substring(value.IndexOf(start) + start.Length)
    End Function

    Public Shared Function TrimStart(ByVal value As String, ByVal trim As String) As String
        If value = "" Or value Is Nothing Then Return ""
        If value.StartsWith(trim) Then value = GetRight(value, trim)
        Return value
    End Function

    Public Shared Function FixBreak(ByVal value As String) As String
        Dim break As String = Microsoft.VisualBasic.Replace(value, vbCrLf, vbLf)
        Return Microsoft.VisualBasic.Replace(break, vbLf, vbCrLf)
    End Function

    Public Function FixBreak() As String
        Dim break As String = Microsoft.VisualBasic.Replace(_text, vbCrLf, vbLf)
        Return Microsoft.VisualBasic.Replace(break, vbLf, vbCrLf)
    End Function

    Public Shared Function GetRight(ByVal value As String, ByVal index As Integer) As String
        If value = "" OrElse value Is Nothing Then
            value = ""
        End If
        If index < 0 Then Return ""
        If index > value.Length Then Return value
        Return value.Substring(value.Length - index)
    End Function

    Public Function Replace(ByVal toFind As String, ByVal toReplace As String) As String
        Return Microsoft.VisualBasic.Replace(_text, toFind, toReplace)
    End Function

    Public Property Text() As String
        Get
            Return _text
        End Get
        Set(ByVal Value As String)
            _text = Value
        End Set
    End Property
End Class