Imports System.Text.RegularExpressions

Public Class fCompletion
    Inherits System.Windows.Forms.Form

    Private mRichTextBox As RichTextBox
    Public mText As String
    Private _FilterInfo As fTip

#Region " Vom Windows Form Designer generierter Code "

    Public Sub New(ByVal rtb As RichTextBox)
        MyBase.New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen
        mRichTextBox = rtb
    End Sub

    ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Fr Windows Form-Designer erforderlich
    Private components As System.ComponentModel.IContainer

    'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
    'Sie kann mit dem Windows Form-Designer modifiziert werden.
    'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
    Friend WithEvents lb As System.Windows.Forms.ListBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.lb = New System.Windows.Forms.ListBox
        Me.SuspendLayout()
        '
        'lb
        '
        Me.lb.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lb.Dock = System.Windows.Forms.DockStyle.Fill
        Me.lb.Location = New System.Drawing.Point(0, 0)
        Me.lb.Name = "lb"
        Me.lb.Size = New System.Drawing.Size(178, 169)
        Me.lb.Sorted = True
        Me.lb.TabIndex = 0
        '
        'fCompletion
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(178, 170)
        Me.ControlBox = False
        Me.Controls.Add(Me.lb)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "fCompletion"
        Me.ShowInTaskbar = False
        Me.StartPosition = System.Windows.Forms.FormStartPosition.Manual
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub fmCompletion_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        _FilterInfo = New fTip
        _FilterInfo.Owner = Me
        AddHandler mRichTextBox.KeyPress, AddressOf rtb_KeyPress
        lb.Items.AddRange(g.Filters.ToArray())
        mText = GetCodeCompletionString()
        SelectItem()
    End Sub

    Public Sub SelectItem()
        lb.SelectedIndex = lb.FindString(mText)
    End Sub

    Private Function GetCodeCompletionString() As String
        Dim s As String = ""
        Dim start As Integer = mRichTextBox.SelectionStart

        For i As Integer = 1 To Start
            s = mRichTextBox.Text.Substring(start - i, 0 + i)
            If Not Regex.Match(s, "^[a-zA-Z0-9].?").Success Then
                s = s.Substring(1)
                Exit For
            End If
        Next

        For Each i As Filter In g.Filters
            If i.Name.ToLower.StartsWith(s.ToLower) Then
                Return s
            End If
        Next

        Return ""
    End Function

    Private Sub rtb_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs)
        Select Case e.KeyChar
            Case Chr(8)
                If mText = "" Then
                    g.FormMain.CloseCodeCompletion()
                Else
                    mText = mText.Substring(0, mText.Length - 1)
                End If
            Case Chr(13)
                g.FormMain.CloseCodeCompletion()
            Case Chr(32)
                If Control.ModifierKeys <> Keys.Control Then
                    g.FormMain.CloseCodeCompletion()
                End If
            Case "."c
            Case Else
                mText += e.KeyChar
        End Select
        SelectItem()
    End Sub

    Private Sub lb_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles lb.DoubleClick
        SendEnter()
    End Sub

    Private Sub SendEnter()
        WinAPI.User32.PostMessage(mRichTextBox.Handle, Convert.ToUInt32(WinAPI.Window.WM.KEYDOWN), CInt(Keys.Enter), 0)
    End Sub

    Private Sub lb_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lb.Click
        mRichTextBox.Focus()
    End Sub

    Private Sub lb_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lb.SelectedIndexChanged
        Try
            Dim f As Filter = CType(lb.SelectedItem, Filter)
            _FilterInfo.Left = Left + Width
            Dim t As Integer = Top + (lb.SelectedIndex - lb.TopIndex) * lb.ItemHeight
            If t < Top Then
                t = Top
            End If
            _FilterInfo.Top = t
            _FilterInfo.rtb.Text = f.Plugin.Name + "::" + f.Name + vbCrLf + vbCrLf + _
                g.GetParameterText(f)
            _FilterInfo.AdjustSize()
            _FilterInfo.Show()
        Catch ex As Exception
        End Try
    End Sub
End Class