Public Class fKeys
    Inherits System.Windows.Forms.Form

    Public _Menu As Menu
    Public _Settings As ArrayList

#Region " Windows Form Designer generated code "

    Public Sub New(ByVal m As Menu, ByVal settings As ArrayList)
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()
        _Menu = m
        _Settings = settings
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents bEdit As System.Windows.Forms.Button
    Friend WithEvents bCancel As System.Windows.Forms.Button
    Public WithEvents lvKeys As System.Windows.Forms.ListView
    Friend WithEvents bOK As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(fKeys))
        Me.bEdit = New System.Windows.Forms.Button
        Me.bCancel = New System.Windows.Forms.Button
        Me.lvKeys = New System.Windows.Forms.ListView
        Me.bOK = New System.Windows.Forms.Button
        Me.SuspendLayout()
        '
        'bEdit
        '
        Me.bEdit.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.bEdit.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.bEdit.Location = New System.Drawing.Point(8, 287)
        Me.bEdit.Name = "bEdit"
        Me.bEdit.Size = New System.Drawing.Size(80, 24)
        Me.bEdit.TabIndex = 5
        Me.bEdit.Text = "Edit"
        '
        'bCancel
        '
        Me.bCancel.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.bCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.bCancel.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.bCancel.Location = New System.Drawing.Point(242, 287)
        Me.bCancel.Name = "bCancel"
        Me.bCancel.Size = New System.Drawing.Size(80, 24)
        Me.bCancel.TabIndex = 4
        Me.bCancel.Text = "Cancel"
        '
        'lvKeys
        '
        Me.lvKeys.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lvKeys.FullRowSelect = True
        Me.lvKeys.GridLines = True
        Me.lvKeys.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable
        Me.lvKeys.HideSelection = False
        Me.lvKeys.Location = New System.Drawing.Point(8, 9)
        Me.lvKeys.MultiSelect = False
        Me.lvKeys.Name = "lvKeys"
        Me.lvKeys.Size = New System.Drawing.Size(314, 270)
        Me.lvKeys.TabIndex = 3
        Me.lvKeys.View = System.Windows.Forms.View.Details
        '
        'bOK
        '
        Me.bOK.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.bOK.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.bOK.Location = New System.Drawing.Point(152, 288)
        Me.bOK.Name = "bOK"
        Me.bOK.Size = New System.Drawing.Size(80, 24)
        Me.bOK.TabIndex = 6
        Me.bOK.Text = "OK"
        '
        'fKeys
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(330, 320)
        Me.Controls.Add(Me.bOK)
        Me.Controls.Add(Me.bEdit)
        Me.Controls.Add(Me.bCancel)
        Me.Controls.Add(Me.lvKeys)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "fKeys"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
        Me.Text = "Keys"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub Populate()
        lvKeys.Items.Clear()

        For Each i As ExtendedMenuItem In ExtendedMenuItem.GetItems(_Menu)
            If i.Text <> "-" AndAlso _
                i.MenuItems.Count = 0 AndAlso _
                i.ShowShortcut AndAlso _
                i.CanEdit Then

                Dim k As KeyCombination = i.KeyCombination
                k.Name = i.GetID
                Dim it As New KeyCombinationListViewItem
                it.KeyCombination = k
                it.Text = i.GetPath
                it.SubItems.Add(it.KeyCombination.ToString())
                lvKeys.Items.Add(it)
            End If
        Next
    End Sub

    Private Sub Edit()
        If lvKeys.SelectedItems.Count > 0 Then
            Dim index As Integer = lvKeys.SelectedIndices(0)
            Dim it As KeyCombinationListViewItem = CType(lvKeys.SelectedItems(0), KeyCombinationListViewItem)
            Dim f As fKeyCombination = New fKeyCombination(it.KeyCombination)
            f.ShowDialog()
            it.KeyCombination = f.KeyCombination
            it.SubItems(1).Text = it.KeyCombination.ToString()
        End If
    End Sub

    Private Sub bEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bEdit.Click
        Edit()
    End Sub

    Private Sub lvKeys_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles lvKeys.KeyDown
        If e.KeyCode = Keys.Enter Then
            Edit()
        End If
    End Sub

    Private Sub fKeys_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyUp
        If e.KeyCode = Keys.Escape Then
            Close()
        End If
    End Sub

    Private Sub lvKeys_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles lvKeys.DoubleClick
        Edit()
    End Sub

    Private Sub fKeys_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        g.Translator.Translate(Me)
        lvKeys.Columns.Add(g.GetResource("Action"), Convert.ToInt32(lvKeys.Width / 3 * 2 - 12), HorizontalAlignment.Left)
        lvKeys.Columns.Add(g.GetResource("Key"), Convert.ToInt32(lvKeys.Width / 3 - 12), HorizontalAlignment.Left)
        Populate()
        lvKeys.Items(0).Selected = True
    End Sub

    Private Class KeyCombinationListViewItem
        Inherits ListViewItem

        Private _keyCombination As KeyCombination

        Public Property KeyCombination() As KeyCombination
            Get
                Return _keyCombination
            End Get
            Set(ByVal Value As KeyCombination)
                _keyCombination = Value
            End Set
        End Property
    End Class

    Private Sub bOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bOK.Click
        _Settings.Clear()

        For Each i As KeyCombinationListViewItem In lvKeys.Items
            _Settings.Add(i.KeyCombination)
            For Each i2 As ExtendedMenuItem In ExtendedMenuItem.GetItems(_Menu)
                If i.KeyCombination.Name = i2.GetID Then
                    i2.KeyCombination = i.KeyCombination
                End If
            Next
        Next

        Close()
    End Sub
End Class