Imports System.Text.RegularExpressions
Imports System.Globalization
Imports System.IO
Imports System.Threading
Imports System.ComponentModel
Imports System.Drawing.Design

Public Class fMain
    Inherits System.Windows.Forms.Form

    Private mContextMenuProfiles As New ContextMenu
    Private mUndo As New Stack
    Private mOldScript As String
    Private mBlockRTB_SelectionChanged As Boolean
    Public mPath As String = ""
    Private mChanged As String = ""
    Private mVersion As String = "1.0b"
    Private mFormCompletion As fCompletion
    Private mFormParameterInfo As fTip
    Public mSettingsFile As String
    Public mEditorSignaturs As New ArrayList
    Public _ParameterInfoFilter As Filter
    Public _CurrentFilter As Filter
    Private _AlreadyProcessed As String

#Region " Vom Windows Form Designer generierter Code "
    Public Sub New()
        MyBase.New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.

        InitializeComponent()

        mSettingsFile = Registry.ReadApplicationString("settings file")

        If mSettingsFile = "" Then
            mSettingsFile = IO.Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), "AVSEdit Settings.bin")
            Registry.WriteApplication("settings file", mSettingsFile)
        End If

        Settings.Load(g.Settings, mSettingsFile)

        g.Translator.Load()
        g.Translator.Translate(Me)
        g.Translator.Translate(mmMainMenu)
        g.Translator.Translate(tbToolBar)
        g.Translator.Translate(cmTreeView)
        g.Translator.Translate(cmEditor)
        g.Translator.Translate(cmParameter)

        Text = "AVSEdit " + mVersion
    End Sub

    ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Fr Windows Form-Designer erforderlich
    Private components As System.ComponentModel.IContainer

    'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
    'Sie kann mit dem Windows Form-Designer modifiziert werden.
    'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
    Friend WithEvents tbbCopy As ExtendedToolBarButton
    Friend WithEvents tbbCut As ExtendedToolBarButton
    Friend WithEvents tbbPaste As ExtendedToolBarButton
    Friend WithEvents tbbUndo As ExtendedToolBarButton
    Friend WithEvents tbbComment As ExtendedToolBarButton
    Friend WithEvents tbbUndoComment As ExtendedToolBarButton
    Friend WithEvents tbbPreview As ExtendedToolBarButton
    Friend WithEvents miFile As ExtendedMenuItem
    Friend WithEvents miExit As ExtendedMenuItem
    Friend WithEvents miEdit As ExtendedMenuItem
    Friend WithEvents miCopy As ExtendedMenuItem
    Friend WithEvents miCut As ExtendedMenuItem
    Friend WithEvents miPaste As ExtendedMenuItem
    Friend WithEvents miUndo As ExtendedMenuItem
    Friend WithEvents miComment As ExtendedMenuItem
    Friend WithEvents miUndoComment As ExtendedMenuItem
    Friend WithEvents miExtras As ExtendedMenuItem
    Friend WithEvents pnRTB As System.Windows.Forms.Panel
    Friend WithEvents tbNameProfile As System.Windows.Forms.TextBox
    Friend WithEvents lbProfiles As ExtendedListBox
    Friend WithEvents dcProfiles As DockingSuite.DockControl
    Friend WithEvents tbPreviewProfile As System.Windows.Forms.TextBox
    Friend WithEvents dcParameters As DockingSuite.DockControl
    Friend WithEvents dcFilters As DockingSuite.DockControl
    Friend WithEvents tvFilters As System.Windows.Forms.TreeView
    Friend WithEvents DockHost As DockingSuite.DockHost
    Friend WithEvents cmTreeView As ExtendedContextMenu
    Friend WithEvents cmEditor As ExtendedContextMenu
    Friend WithEvents miCutContext As ExtendedMenuItem
    Friend WithEvents miPasteContext As ExtendedMenuItem
    Friend WithEvents il16 As System.Windows.Forms.ImageList
    Friend WithEvents miSeperatorEdit0 As ExtendedMenuItem
    Friend WithEvents miSeperatorEdit1 As ExtendedMenuItem
    Friend WithEvents miSeperatorContext As ExtendedMenuItem
    Friend WithEvents miCommentContext As ExtendedMenuItem
    Friend WithEvents miCopyContext As ExtendedMenuItem
    Friend WithEvents miHelp As ExtendedMenuItem
    Friend WithEvents miPreview As ExtendedMenuItem
    Friend WithEvents miUndoCommentContext As ExtendedMenuItem
    Friend WithEvents mmMainMenu As ExtendedMainMenu
    Friend WithEvents tbToolBar As ExtendedToolBar
    Friend WithEvents dp_DockPanel As DockingSuite.DockPanel
    Friend WithEvents rtb As System.Windows.Forms.RichTextBox
    Friend WithEvents bFilterHelp As System.Windows.Forms.Button
    Friend WithEvents bFilterPreview As System.Windows.Forms.Button
    Friend WithEvents bPasteProfile As System.Windows.Forms.Button
    Friend WithEvents bLoadProfile As System.Windows.Forms.Button
    Friend WithEvents bSaveSelectionProfile As System.Windows.Forms.Button
    Friend WithEvents bDeleteProfile As System.Windows.Forms.Button
    Friend WithEvents bSaveProfile As System.Windows.Forms.Button
    Friend WithEvents miFilterList As ExtendedMenuItem
    Friend WithEvents miViewAll As ExtendedMenuItem
    Friend WithEvents miViewByCategory As ExtendedMenuItem
    Friend WithEvents miViewByPlugin As ExtendedMenuItem
    Friend WithEvents miTreeViewSeperator0 As ExtendedMenuItem
    Friend WithEvents miTreeViewHelp As ExtendedMenuItem
    Friend WithEvents miNew As ExtendedMenuItem
    Friend WithEvents miOpen As ExtendedMenuItem
    Friend WithEvents miSave As ExtendedMenuItem
    Friend WithEvents miSaveAs As ExtendedMenuItem
    Friend WithEvents sbStatusBar As System.Windows.Forms.StatusBar
    Friend WithEvents miFileSeperator0 As ExtendedMenuItem
    Friend WithEvents miRecentFiles As ExtendedMenuItem
    Friend WithEvents miFileSeperator1 As ExtendedMenuItem
    Friend WithEvents tbbSep0 As AVSEdit.ExtendedToolBarButton
    Friend WithEvents tbbSep1 As AVSEdit.ExtendedToolBarButton
    Friend WithEvents tbbSep2 As AVSEdit.ExtendedToolBarButton
    Friend WithEvents tbbSep3 As AVSEdit.ExtendedToolBarButton
    Friend WithEvents tbbOpen As ExtendedToolBarButton
    Friend WithEvents tbbSave As ExtendedToolBarButton
    Friend WithEvents miInfo As ExtendedMenuItem
    Friend WithEvents bFilterEditor As System.Windows.Forms.Button
    Friend WithEvents tbbNew As ExtendedToolBarButton
    Friend WithEvents miOpenFile As ExtendedMenuItem
    Friend WithEvents miGPL As ExtendedMenuItem
    Friend WithEvents miLanguage As ExtendedMenuItem
    Friend WithEvents miOpenPluginDir As ExtendedMenuItem
    Friend WithEvents miOptions As ExtendedMenuItem
    Friend WithEvents MenuItem1 As ExtendedMenuItem
    Friend WithEvents MenuItem2 As ExtendedMenuItem
    Friend WithEvents MenuItem3 As ExtendedMenuItem
    Friend WithEvents miHelpfile As ExtendedMenuItem
    Friend WithEvents tbbHelp As ExtendedToolBarButton
    Friend WithEvents miExternalPreview As ExtendedMenuItem
    Friend WithEvents miChangelog As ExtendedMenuItem
    Friend WithEvents pgParameters As System.Windows.Forms.PropertyGrid
    Friend WithEvents cbGridObjects As System.Windows.Forms.ComboBox
    Friend WithEvents cmParameter As System.Windows.Forms.ContextMenu
    Friend WithEvents miReset As ExtendedMenuItem
    Friend WithEvents miParameterHelp As ExtendedMenuItem
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(fMain))
        Me.tbToolBar = New AVSEdit.ExtendedToolBar
        Me.tbbSep0 = New AVSEdit.ExtendedToolBarButton
        Me.tbbNew = New AVSEdit.ExtendedToolBarButton
        Me.miNew = New AVSEdit.ExtendedMenuItem
        Me.tbbOpen = New AVSEdit.ExtendedToolBarButton
        Me.miOpen = New AVSEdit.ExtendedMenuItem
        Me.tbbSave = New AVSEdit.ExtendedToolBarButton
        Me.miSave = New AVSEdit.ExtendedMenuItem
        Me.tbbSep1 = New AVSEdit.ExtendedToolBarButton
        Me.tbbCut = New AVSEdit.ExtendedToolBarButton
        Me.miCut = New AVSEdit.ExtendedMenuItem
        Me.tbbCopy = New AVSEdit.ExtendedToolBarButton
        Me.miCopy = New AVSEdit.ExtendedMenuItem
        Me.tbbPaste = New AVSEdit.ExtendedToolBarButton
        Me.miPaste = New AVSEdit.ExtendedMenuItem
        Me.tbbSep2 = New AVSEdit.ExtendedToolBarButton
        Me.tbbUndo = New AVSEdit.ExtendedToolBarButton
        Me.miUndo = New AVSEdit.ExtendedMenuItem
        Me.tbbComment = New AVSEdit.ExtendedToolBarButton
        Me.miComment = New AVSEdit.ExtendedMenuItem
        Me.tbbUndoComment = New AVSEdit.ExtendedToolBarButton
        Me.miUndoComment = New AVSEdit.ExtendedMenuItem
        Me.tbbPreview = New AVSEdit.ExtendedToolBarButton
        Me.miPreview = New AVSEdit.ExtendedMenuItem
        Me.tbbSep3 = New AVSEdit.ExtendedToolBarButton
        Me.tbbHelp = New AVSEdit.ExtendedToolBarButton
        Me.miHelpfile = New AVSEdit.ExtendedMenuItem
        Me.il16 = New System.Windows.Forms.ImageList(Me.components)
        Me.cmEditor = New AVSEdit.ExtendedContextMenu
        Me.miCutContext = New AVSEdit.ExtendedMenuItem
        Me.miCopyContext = New AVSEdit.ExtendedMenuItem
        Me.miPasteContext = New AVSEdit.ExtendedMenuItem
        Me.miSeperatorContext = New AVSEdit.ExtendedMenuItem
        Me.miCommentContext = New AVSEdit.ExtendedMenuItem
        Me.miUndoCommentContext = New AVSEdit.ExtendedMenuItem
        Me.rtb = New System.Windows.Forms.RichTextBox
        Me.sbStatusBar = New System.Windows.Forms.StatusBar
        Me.mmMainMenu = New AVSEdit.ExtendedMainMenu
        Me.miFile = New AVSEdit.ExtendedMenuItem
        Me.miFileSeperator0 = New AVSEdit.ExtendedMenuItem
        Me.miOpenFile = New AVSEdit.ExtendedMenuItem
        Me.miFileSeperator1 = New AVSEdit.ExtendedMenuItem
        Me.miSaveAs = New AVSEdit.ExtendedMenuItem
        Me.MenuItem1 = New AVSEdit.ExtendedMenuItem
        Me.miRecentFiles = New AVSEdit.ExtendedMenuItem
        Me.MenuItem2 = New AVSEdit.ExtendedMenuItem
        Me.miExit = New AVSEdit.ExtendedMenuItem
        Me.miEdit = New AVSEdit.ExtendedMenuItem
        Me.miSeperatorEdit0 = New AVSEdit.ExtendedMenuItem
        Me.miSeperatorEdit1 = New AVSEdit.ExtendedMenuItem
        Me.miExtras = New AVSEdit.ExtendedMenuItem
        Me.miExternalPreview = New AVSEdit.ExtendedMenuItem
        Me.miFilterList = New AVSEdit.ExtendedMenuItem
        Me.miOpenPluginDir = New AVSEdit.ExtendedMenuItem
        Me.miLanguage = New AVSEdit.ExtendedMenuItem
        Me.MenuItem3 = New AVSEdit.ExtendedMenuItem
        Me.miOptions = New AVSEdit.ExtendedMenuItem
        Me.miHelp = New AVSEdit.ExtendedMenuItem
        Me.miGPL = New AVSEdit.ExtendedMenuItem
        Me.miChangelog = New AVSEdit.ExtendedMenuItem
        Me.miInfo = New AVSEdit.ExtendedMenuItem
        Me.DockHost = New DockingSuite.DockHost
        Me.dp_DockPanel = New DockingSuite.DockPanel
        Me.dcParameters = New DockingSuite.DockControl
        Me.cbGridObjects = New System.Windows.Forms.ComboBox
        Me.pgParameters = New System.Windows.Forms.PropertyGrid
        Me.cmParameter = New System.Windows.Forms.ContextMenu
        Me.miReset = New AVSEdit.ExtendedMenuItem
        Me.miParameterHelp = New AVSEdit.ExtendedMenuItem
        Me.bFilterEditor = New System.Windows.Forms.Button
        Me.bFilterPreview = New System.Windows.Forms.Button
        Me.bFilterHelp = New System.Windows.Forms.Button
        Me.dcFilters = New DockingSuite.DockControl
        Me.tvFilters = New System.Windows.Forms.TreeView
        Me.cmTreeView = New AVSEdit.ExtendedContextMenu
        Me.miViewAll = New AVSEdit.ExtendedMenuItem
        Me.miViewByCategory = New AVSEdit.ExtendedMenuItem
        Me.miViewByPlugin = New AVSEdit.ExtendedMenuItem
        Me.miTreeViewSeperator0 = New AVSEdit.ExtendedMenuItem
        Me.miTreeViewHelp = New AVSEdit.ExtendedMenuItem
        Me.dcProfiles = New DockingSuite.DockControl
        Me.tbPreviewProfile = New System.Windows.Forms.TextBox
        Me.bPasteProfile = New System.Windows.Forms.Button
        Me.bLoadProfile = New System.Windows.Forms.Button
        Me.bSaveSelectionProfile = New System.Windows.Forms.Button
        Me.bDeleteProfile = New System.Windows.Forms.Button
        Me.bSaveProfile = New System.Windows.Forms.Button
        Me.lbProfiles = New AVSEdit.ExtendedListBox
        Me.tbNameProfile = New System.Windows.Forms.TextBox
        Me.pnRTB = New System.Windows.Forms.Panel
        Me.DockHost.SuspendLayout()
        Me.dp_DockPanel.SuspendLayout()
        Me.dcParameters.SuspendLayout()
        Me.dcFilters.SuspendLayout()
        Me.dcProfiles.SuspendLayout()
        Me.pnRTB.SuspendLayout()
        Me.SuspendLayout()
        '
        'tbToolBar
        '
        Me.tbToolBar.Appearance = System.Windows.Forms.ToolBarAppearance.Flat
        Me.tbToolBar.Buttons.AddRange(New System.Windows.Forms.ToolBarButton() {Me.tbbSep0, Me.tbbNew, Me.tbbOpen, Me.tbbSave, Me.tbbSep1, Me.tbbCut, Me.tbbCopy, Me.tbbPaste, Me.tbbSep2, Me.tbbUndo, Me.tbbComment, Me.tbbUndoComment, Me.tbbPreview, Me.tbbSep3, Me.tbbHelp})
        Me.tbToolBar.ButtonSize = New System.Drawing.Size(20, 20)
        Me.tbToolBar.DropDownArrows = True
        Me.tbToolBar.ImageList = Me.il16
        Me.tbToolBar.Location = New System.Drawing.Point(0, 0)
        Me.tbToolBar.Name = "tbToolBar"
        Me.tbToolBar.ShowToolTips = True
        Me.tbToolBar.Size = New System.Drawing.Size(768, 28)
        Me.tbToolBar.TabIndex = 0
        '
        'tbbSep0
        '
        Me.tbbSep0.MenuItem = Nothing
        Me.tbbSep0.Style = System.Windows.Forms.ToolBarButtonStyle.Separator
        '
        'tbbNew
        '
        Me.tbbNew.ImageIndex = 14
        Me.tbbNew.MenuItem = Me.miNew
        '
        'miNew
        '
        Me.miNew.EnglishText = Nothing
        Me.miNew.ImageIndex = 14
        Me.miNew.Index = 0
        Me.miNew.KeyCombination = New AVSEdit.KeyCombination(Nothing, AVSEdit.KeyCombination.Keys.Control, AVSEdit.KeyCombination.Keys.N)
        Me.miNew.OwnerDraw = True
        Me.miNew.Text = "New"
        '
        'tbbOpen
        '
        Me.tbbOpen.ImageIndex = 11
        Me.tbbOpen.MenuItem = Me.miOpen
        '
        'miOpen
        '
        Me.miOpen.EnglishText = Nothing
        Me.miOpen.ImageIndex = 11
        Me.miOpen.Index = 2
        Me.miOpen.KeyCombination = New AVSEdit.KeyCombination(Nothing, AVSEdit.KeyCombination.Keys.Control, AVSEdit.KeyCombination.Keys.O)
        Me.miOpen.OwnerDraw = True
        Me.miOpen.Text = "Open Script"
        '
        'tbbSave
        '
        Me.tbbSave.ImageIndex = 12
        Me.tbbSave.MenuItem = Me.miSave
        '
        'miSave
        '
        Me.miSave.EnglishText = Nothing
        Me.miSave.ImageIndex = 12
        Me.miSave.Index = 5
        Me.miSave.KeyCombination = New AVSEdit.KeyCombination(Nothing, AVSEdit.KeyCombination.Keys.Control, AVSEdit.KeyCombination.Keys.S)
        Me.miSave.OwnerDraw = True
        Me.miSave.Text = "Save"
        '
        'tbbSep1
        '
        Me.tbbSep1.MenuItem = Nothing
        Me.tbbSep1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator
        '
        'tbbCut
        '
        Me.tbbCut.ImageIndex = 9
        Me.tbbCut.MenuItem = Me.miCut
        Me.tbbCut.Tag = ""
        Me.tbbCut.ToolTipText = "Cut"
        '
        'miCut
        '
        Me.miCut.CanEdit = False
        Me.miCut.EnglishText = Nothing
        Me.miCut.HandleKey = False
        Me.miCut.ImageIndex = 9
        Me.miCut.Index = 1
        Me.miCut.KeyCombination = New AVSEdit.KeyCombination(Nothing, AVSEdit.KeyCombination.Keys.Control, AVSEdit.KeyCombination.Keys.X)
        Me.miCut.OwnerDraw = True
        Me.miCut.Text = "Cut"
        '
        'tbbCopy
        '
        Me.tbbCopy.ImageIndex = 8
        Me.tbbCopy.MenuItem = Me.miCopy
        Me.tbbCopy.Tag = ""
        Me.tbbCopy.ToolTipText = "Copy"
        '
        'miCopy
        '
        Me.miCopy.CanEdit = False
        Me.miCopy.EnglishText = Nothing
        Me.miCopy.HandleKey = False
        Me.miCopy.ImageIndex = 8
        Me.miCopy.Index = 0
        Me.miCopy.KeyCombination = New AVSEdit.KeyCombination(Nothing, AVSEdit.KeyCombination.Keys.Control, AVSEdit.KeyCombination.Keys.C)
        Me.miCopy.OwnerDraw = True
        Me.miCopy.Text = "Copy"
        '
        'tbbPaste
        '
        Me.tbbPaste.ImageIndex = 10
        Me.tbbPaste.MenuItem = Me.miPaste
        Me.tbbPaste.Tag = ""
        Me.tbbPaste.ToolTipText = "Paste"
        '
        'miPaste
        '
        Me.miPaste.CanEdit = False
        Me.miPaste.EnglishText = Nothing
        Me.miPaste.HandleKey = False
        Me.miPaste.ImageIndex = 10
        Me.miPaste.Index = 2
        Me.miPaste.KeyCombination = New AVSEdit.KeyCombination(Nothing, AVSEdit.KeyCombination.Keys.Control, AVSEdit.KeyCombination.Keys.V)
        Me.miPaste.OwnerDraw = True
        Me.miPaste.Text = "Paste"
        '
        'tbbSep2
        '
        Me.tbbSep2.MenuItem = Nothing
        Me.tbbSep2.Style = System.Windows.Forms.ToolBarButtonStyle.Separator
        '
        'tbbUndo
        '
        Me.tbbUndo.ImageIndex = 13
        Me.tbbUndo.MenuItem = Me.miUndo
        Me.tbbUndo.Tag = ""
        Me.tbbUndo.ToolTipText = "Undo"
        '
        'miUndo
        '
        Me.miUndo.EnglishText = Nothing
        Me.miUndo.ImageIndex = 13
        Me.miUndo.Index = 4
        Me.miUndo.KeyCombination = New AVSEdit.KeyCombination(Nothing, AVSEdit.KeyCombination.Keys.Control, AVSEdit.KeyCombination.Keys.Z)
        Me.miUndo.OwnerDraw = True
        Me.miUndo.Text = "Undo"
        '
        'tbbComment
        '
        Me.tbbComment.ImageIndex = 5
        Me.tbbComment.MenuItem = Me.miComment
        Me.tbbComment.Tag = ""
        Me.tbbComment.ToolTipText = "Comment"
        '
        'miComment
        '
        Me.miComment.EnglishText = Nothing
        Me.miComment.ImageIndex = 5
        Me.miComment.Index = 6
        Me.miComment.KeyCombination = New AVSEdit.KeyCombination(Nothing, AVSEdit.KeyCombination.Keys.Control, AVSEdit.KeyCombination.Keys.OemQuestion)
        Me.miComment.OwnerDraw = True
        Me.miComment.Text = "Comment"
        '
        'tbbUndoComment
        '
        Me.tbbUndoComment.ImageIndex = 6
        Me.tbbUndoComment.MenuItem = Me.miUndoComment
        Me.tbbUndoComment.Tag = ""
        Me.tbbUndoComment.ToolTipText = "Undo Comment"
        '
        'miUndoComment
        '
        Me.miUndoComment.EnglishText = Nothing
        Me.miUndoComment.ImageIndex = 6
        Me.miUndoComment.Index = 7
        Me.miUndoComment.KeyCombination = New AVSEdit.KeyCombination(Nothing, AVSEdit.KeyCombination.Keys.Alt, AVSEdit.KeyCombination.Keys.OemQuestion)
        Me.miUndoComment.OwnerDraw = True
        Me.miUndoComment.Text = "Undo Comment"
        '
        'tbbPreview
        '
        Me.tbbPreview.ImageIndex = 7
        Me.tbbPreview.MenuItem = Me.miPreview
        Me.tbbPreview.Tag = ""
        Me.tbbPreview.ToolTipText = "Preview"
        '
        'miPreview
        '
        Me.miPreview.EnglishText = Nothing
        Me.miPreview.ImageIndex = 7
        Me.miPreview.Index = 0
        Me.miPreview.KeyCombination = New AVSEdit.KeyCombination(Nothing, AVSEdit.KeyCombination.Keys.None, AVSEdit.KeyCombination.Keys.F5)
        Me.miPreview.OwnerDraw = True
        Me.miPreview.Text = "Preview..."
        '
        'tbbSep3
        '
        Me.tbbSep3.MenuItem = Nothing
        Me.tbbSep3.Style = System.Windows.Forms.ToolBarButtonStyle.Separator
        '
        'tbbHelp
        '
        Me.tbbHelp.ImageIndex = 1
        Me.tbbHelp.MenuItem = Me.miHelpfile
        '
        'miHelpfile
        '
        Me.miHelpfile.EnglishText = Nothing
        Me.miHelpfile.ImageIndex = 1
        Me.miHelpfile.Index = 0
        Me.miHelpfile.KeyCombination = New AVSEdit.KeyCombination(Nothing, AVSEdit.KeyCombination.Keys.None, AVSEdit.KeyCombination.Keys.F1)
        Me.miHelpfile.OwnerDraw = True
        Me.miHelpfile.Text = "Content"
        '
        'il16
        '
        Me.il16.ImageSize = New System.Drawing.Size(16, 16)
        Me.il16.ImageStream = CType(resources.GetObject("il16.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.il16.TransparentColor = System.Drawing.Color.Transparent
        '
        'cmEditor
        '
        Me.cmEditor.ImageList = Me.il16
        Me.cmEditor.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miCutContext, Me.miCopyContext, Me.miPasteContext, Me.miSeperatorContext, Me.miCommentContext, Me.miUndoCommentContext})
        Me.cmEditor.RightToLeft = System.Windows.Forms.RightToLeft.No
        '
        'miCutContext
        '
        Me.miCutContext.EnglishText = Nothing
        Me.miCutContext.ImageIndex = 9
        Me.miCutContext.Index = 0
        Me.miCutContext.OwnerDraw = True
        Me.miCutContext.Text = "Cut"
        '
        'miCopyContext
        '
        Me.miCopyContext.EnglishText = Nothing
        Me.miCopyContext.ImageIndex = 8
        Me.miCopyContext.Index = 1
        Me.miCopyContext.OwnerDraw = True
        Me.miCopyContext.Text = "Copy"
        '
        'miPasteContext
        '
        Me.miPasteContext.EnglishText = Nothing
        Me.miPasteContext.ImageIndex = 10
        Me.miPasteContext.Index = 2
        Me.miPasteContext.OwnerDraw = True
        Me.miPasteContext.Text = "Paste"
        '
        'miSeperatorContext
        '
        Me.miSeperatorContext.EnglishText = Nothing
        Me.miSeperatorContext.Index = 3
        Me.miSeperatorContext.OwnerDraw = True
        Me.miSeperatorContext.ShowShortcut = False
        Me.miSeperatorContext.Text = "-"
        '
        'miCommentContext
        '
        Me.miCommentContext.EnglishText = Nothing
        Me.miCommentContext.ImageIndex = 5
        Me.miCommentContext.Index = 4
        Me.miCommentContext.OwnerDraw = True
        Me.miCommentContext.Text = "Comment"
        '
        'miUndoCommentContext
        '
        Me.miUndoCommentContext.EnglishText = Nothing
        Me.miUndoCommentContext.ImageIndex = 6
        Me.miUndoCommentContext.Index = 5
        Me.miUndoCommentContext.OwnerDraw = True
        Me.miUndoCommentContext.Text = "Undo Comment"
        '
        'rtb
        '
        Me.rtb.AcceptsTab = True
        Me.rtb.AllowDrop = True
        Me.rtb.AutoWordSelection = True
        Me.rtb.ContextMenu = Me.cmEditor
        Me.rtb.DetectUrls = False
        Me.rtb.Dock = System.Windows.Forms.DockStyle.Fill
        Me.rtb.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.rtb.HideSelection = False
        Me.rtb.Location = New System.Drawing.Point(0, 0)
        Me.rtb.Name = "rtb"
        Me.rtb.Size = New System.Drawing.Size(528, 469)
        Me.rtb.TabIndex = 31
        Me.rtb.Text = ""
        Me.rtb.WordWrap = False
        '
        'sbStatusBar
        '
        Me.sbStatusBar.Location = New System.Drawing.Point(0, 497)
        Me.sbStatusBar.Name = "sbStatusBar"
        Me.sbStatusBar.Size = New System.Drawing.Size(768, 24)
        Me.sbStatusBar.TabIndex = 32
        '
        'mmMainMenu
        '
        Me.mmMainMenu.ImageList = Me.il16
        Me.mmMainMenu.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miFile, Me.miEdit, Me.miExtras, Me.miHelp})
        '
        'miFile
        '
        Me.miFile.EnglishText = Nothing
        Me.miFile.Index = 0
        Me.miFile.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miNew, Me.miFileSeperator0, Me.miOpen, Me.miOpenFile, Me.miFileSeperator1, Me.miSave, Me.miSaveAs, Me.MenuItem1, Me.miRecentFiles, Me.MenuItem2, Me.miExit})
        Me.miFile.ShowShortcut = False
        Me.miFile.Text = "File"
        '
        'miFileSeperator0
        '
        Me.miFileSeperator0.EnglishText = Nothing
        Me.miFileSeperator0.Index = 1
        Me.miFileSeperator0.ShowShortcut = False
        Me.miFileSeperator0.Text = "-"
        '
        'miOpenFile
        '
        Me.miOpenFile.EnglishText = Nothing
        Me.miOpenFile.Index = 3
        Me.miOpenFile.KeyCombination = New AVSEdit.KeyCombination(Nothing, AVSEdit.KeyCombination.Keys.Control, AVSEdit.KeyCombination.Keys.F)
        Me.miOpenFile.OwnerDraw = True
        Me.miOpenFile.Text = "Open File(s)"
        '
        'miFileSeperator1
        '
        Me.miFileSeperator1.EnglishText = Nothing
        Me.miFileSeperator1.Index = 4
        Me.miFileSeperator1.ShowShortcut = False
        Me.miFileSeperator1.Text = "-"
        '
        'miSaveAs
        '
        Me.miSaveAs.EnglishText = Nothing
        Me.miSaveAs.Index = 6
        Me.miSaveAs.OwnerDraw = True
        Me.miSaveAs.Text = "Save As"
        '
        'MenuItem1
        '
        Me.MenuItem1.EnglishText = Nothing
        Me.MenuItem1.Index = 7
        Me.MenuItem1.ShowShortcut = False
        Me.MenuItem1.Text = "-"
        '
        'miRecentFiles
        '
        Me.miRecentFiles.EnglishText = Nothing
        Me.miRecentFiles.Index = 8
        Me.miRecentFiles.OwnerDraw = True
        Me.miRecentFiles.ShowShortcut = False
        Me.miRecentFiles.Text = "Recent Files"
        '
        'MenuItem2
        '
        Me.MenuItem2.EnglishText = Nothing
        Me.MenuItem2.Index = 9
        Me.MenuItem2.ShowShortcut = False
        Me.MenuItem2.Text = "-"
        '
        'miExit
        '
        Me.miExit.EnglishText = Nothing
        Me.miExit.ImageIndex = 4
        Me.miExit.Index = 10
        Me.miExit.KeyCombination = New AVSEdit.KeyCombination(Nothing, AVSEdit.KeyCombination.Keys.Alt, AVSEdit.KeyCombination.Keys.X)
        Me.miExit.OwnerDraw = True
        Me.miExit.Text = "Exit"
        '
        'miEdit
        '
        Me.miEdit.EnglishText = Nothing
        Me.miEdit.Index = 1
        Me.miEdit.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miCopy, Me.miCut, Me.miPaste, Me.miSeperatorEdit0, Me.miUndo, Me.miSeperatorEdit1, Me.miComment, Me.miUndoComment})
        Me.miEdit.ShowShortcut = False
        Me.miEdit.Text = "Edit"
        '
        'miSeperatorEdit0
        '
        Me.miSeperatorEdit0.EnglishText = Nothing
        Me.miSeperatorEdit0.Index = 3
        Me.miSeperatorEdit0.ShowShortcut = False
        Me.miSeperatorEdit0.Text = "-"
        '
        'miSeperatorEdit1
        '
        Me.miSeperatorEdit1.EnglishText = Nothing
        Me.miSeperatorEdit1.Index = 5
        Me.miSeperatorEdit1.ShowShortcut = False
        Me.miSeperatorEdit1.Text = "-"
        '
        'miExtras
        '
        Me.miExtras.EnglishText = Nothing
        Me.miExtras.Index = 2
        Me.miExtras.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miPreview, Me.miExternalPreview, Me.miFilterList, Me.miOpenPluginDir, Me.miLanguage, Me.MenuItem3, Me.miOptions})
        Me.miExtras.ShowShortcut = False
        Me.miExtras.Text = "Extras"
        '
        'miExternalPreview
        '
        Me.miExternalPreview.EnglishText = Nothing
        Me.miExternalPreview.Index = 1
        Me.miExternalPreview.KeyCombination = New AVSEdit.KeyCombination(Nothing, AVSEdit.KeyCombination.Keys.None, AVSEdit.KeyCombination.Keys.F6)
        Me.miExternalPreview.OwnerDraw = True
        Me.miExternalPreview.Text = "External Preview..."
        '
        'miFilterList
        '
        Me.miFilterList.CanEdit = False
        Me.miFilterList.EnglishText = Nothing
        Me.miFilterList.HandleKey = False
        Me.miFilterList.Index = 2
        Me.miFilterList.KeyCombination = New AVSEdit.KeyCombination(Nothing, AVSEdit.KeyCombination.Keys.Control, AVSEdit.KeyCombination.Keys.Space)
        Me.miFilterList.OwnerDraw = True
        Me.miFilterList.Text = "Filter List"
        '
        'miOpenPluginDir
        '
        Me.miOpenPluginDir.EnglishText = Nothing
        Me.miOpenPluginDir.Index = 3
        Me.miOpenPluginDir.OwnerDraw = True
        Me.miOpenPluginDir.Text = "Open Plugin Directory..."
        '
        'miLanguage
        '
        Me.miLanguage.EnglishText = Nothing
        Me.miLanguage.Index = 4
        Me.miLanguage.OwnerDraw = True
        Me.miLanguage.ShowShortcut = False
        Me.miLanguage.Text = "Language"
        '
        'MenuItem3
        '
        Me.MenuItem3.EnglishText = Nothing
        Me.MenuItem3.Index = 5
        Me.MenuItem3.ShowShortcut = False
        Me.MenuItem3.Text = "-"
        '
        'miOptions
        '
        Me.miOptions.EnglishText = Nothing
        Me.miOptions.Index = 6
        Me.miOptions.KeyCombination = New AVSEdit.KeyCombination(Nothing, AVSEdit.KeyCombination.Keys.Alt, AVSEdit.KeyCombination.Keys.Enter)
        Me.miOptions.OwnerDraw = True
        Me.miOptions.Text = "Options..."
        '
        'miHelp
        '
        Me.miHelp.EnglishText = Nothing
        Me.miHelp.Index = 3
        Me.miHelp.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miHelpfile, Me.miGPL, Me.miChangelog, Me.miInfo})
        Me.miHelp.ShowShortcut = False
        Me.miHelp.Text = "Help"
        '
        'miGPL
        '
        Me.miGPL.EnglishText = Nothing
        Me.miGPL.Index = 1
        Me.miGPL.OwnerDraw = True
        Me.miGPL.Text = "GPL License"
        '
        'miChangelog
        '
        Me.miChangelog.EnglishText = Nothing
        Me.miChangelog.Index = 2
        Me.miChangelog.OwnerDraw = True
        Me.miChangelog.Text = "Changelog"
        '
        'miInfo
        '
        Me.miInfo.EnglishText = Nothing
        Me.miInfo.ImageIndex = 15
        Me.miInfo.Index = 3
        Me.miInfo.KeyCombination = New AVSEdit.KeyCombination(Nothing, AVSEdit.KeyCombination.Keys.Control, AVSEdit.KeyCombination.Keys.I)
        Me.miInfo.OwnerDraw = True
        Me.miInfo.Text = "Info"
        '
        'DockHost
        '
        Me.DockHost.Controls.Add(Me.dp_DockPanel)
        Me.DockHost.Dock = System.Windows.Forms.DockStyle.Right
        Me.DockHost.Location = New System.Drawing.Point(528, 28)
        Me.DockHost.Name = "DockHost"
        Me.DockHost.Size = New System.Drawing.Size(240, 469)
        Me.DockHost.TabIndex = 33
        '
        'dp_DockPanel
        '
        Me.dp_DockPanel.AutoHide = False
        Me.dp_DockPanel.Controls.Add(Me.dcParameters)
        Me.dp_DockPanel.Controls.Add(Me.dcFilters)
        Me.dp_DockPanel.Controls.Add(Me.dcProfiles)
        Me.dp_DockPanel.DockedHeight = 469
        Me.dp_DockPanel.DockedWidth = 0
        Me.dp_DockPanel.Location = New System.Drawing.Point(4, 0)
        Me.dp_DockPanel.Name = "dp_DockPanel"
        Me.dp_DockPanel.SelectedTab = Me.dcParameters
        Me.dp_DockPanel.Size = New System.Drawing.Size(236, 469)
        Me.dp_DockPanel.TabIndex = 0
        Me.dp_DockPanel.Text = "Docked Panel"
        '
        'dcParameters
        '
        Me.dcParameters.Controls.Add(Me.cbGridObjects)
        Me.dcParameters.Controls.Add(Me.pgParameters)
        Me.dcParameters.Controls.Add(Me.bFilterEditor)
        Me.dcParameters.Controls.Add(Me.bFilterPreview)
        Me.dcParameters.Controls.Add(Me.bFilterHelp)
        Me.dcParameters.Guid = New System.Guid("f0aa5230-28c0-4115-a348-1df2c03e8ca3")
        Me.dcParameters.Location = New System.Drawing.Point(0, 20)
        Me.dcParameters.Name = "dcParameters"
        Me.dcParameters.Size = New System.Drawing.Size(236, 426)
        Me.dcParameters.TabImage = CType(resources.GetObject("dcParameters.TabImage"), System.Drawing.Image)
        Me.dcParameters.TabIndex = 1
        Me.dcParameters.Text = "Parameters"
        '
        'cbGridObjects
        '
        Me.cbGridObjects.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.cbGridObjects.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cbGridObjects.Location = New System.Drawing.Point(0, 8)
        Me.cbGridObjects.Name = "cbGridObjects"
        Me.cbGridObjects.Size = New System.Drawing.Size(234, 21)
        Me.cbGridObjects.TabIndex = 95
        '
        'pgParameters
        '
        Me.pgParameters.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.pgParameters.CommandsVisibleIfAvailable = True
        Me.pgParameters.ContextMenu = Me.cmParameter
        Me.pgParameters.LargeButtons = False
        Me.pgParameters.LineColor = System.Drawing.SystemColors.ScrollBar
        Me.pgParameters.Location = New System.Drawing.Point(0, 32)
        Me.pgParameters.Name = "pgParameters"
        Me.pgParameters.PropertySort = System.Windows.Forms.PropertySort.NoSort
        Me.pgParameters.Size = New System.Drawing.Size(234, 320)
        Me.pgParameters.TabIndex = 94
        Me.pgParameters.ToolbarVisible = False
        Me.pgParameters.ViewBackColor = System.Drawing.SystemColors.Window
        Me.pgParameters.ViewForeColor = System.Drawing.SystemColors.WindowText
        '
        'cmParameter
        '
        Me.cmParameter.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miReset, Me.miParameterHelp})
        '
        'miReset
        '
        Me.miReset.EnglishText = Nothing
        Me.miReset.Index = 0
        Me.miReset.Text = "Reset"
        '
        'miParameterHelp
        '
        Me.miParameterHelp.EnglishText = Nothing
        Me.miParameterHelp.Index = 1
        Me.miParameterHelp.Text = "Help"
        '
        'bFilterEditor
        '
        Me.bFilterEditor.FlatStyle = System.Windows.Forms.FlatStyle.Popup
        Me.bFilterEditor.Location = New System.Drawing.Point(0, 360)
        Me.bFilterEditor.Name = "bFilterEditor"
        Me.bFilterEditor.Size = New System.Drawing.Size(234, 24)
        Me.bFilterEditor.TabIndex = 93
        Me.bFilterEditor.Visible = False
        '
        'bFilterPreview
        '
        Me.bFilterPreview.FlatStyle = System.Windows.Forms.FlatStyle.Popup
        Me.bFilterPreview.Location = New System.Drawing.Point(0, 392)
        Me.bFilterPreview.Name = "bFilterPreview"
        Me.bFilterPreview.Size = New System.Drawing.Size(120, 24)
        Me.bFilterPreview.TabIndex = 91
        Me.bFilterPreview.Tag = "ResFilterPreview"
        Me.bFilterPreview.Text = "Preview"
        Me.bFilterPreview.Visible = False
        '
        'bFilterHelp
        '
        Me.bFilterHelp.FlatStyle = System.Windows.Forms.FlatStyle.Popup
        Me.bFilterHelp.Location = New System.Drawing.Point(128, 392)
        Me.bFilterHelp.Name = "bFilterHelp"
        Me.bFilterHelp.Size = New System.Drawing.Size(106, 24)
        Me.bFilterHelp.TabIndex = 90
        Me.bFilterHelp.Tag = "Opens the help file for the selected filter"
        Me.bFilterHelp.Text = "Help"
        Me.bFilterHelp.Visible = False
        '
        'dcFilters
        '
        Me.dcFilters.Controls.Add(Me.tvFilters)
        Me.dcFilters.Guid = New System.Guid("8930ab9d-917a-4e8a-a46c-b4d35f2adc0d")
        Me.dcFilters.Location = New System.Drawing.Point(0, 20)
        Me.dcFilters.Name = "dcFilters"
        Me.dcFilters.Size = New System.Drawing.Size(236, 426)
        Me.dcFilters.TabImage = CType(resources.GetObject("dcFilters.TabImage"), System.Drawing.Image)
        Me.dcFilters.TabIndex = 2
        Me.dcFilters.Text = "Filters"
        '
        'tvFilters
        '
        Me.tvFilters.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.tvFilters.ContextMenu = Me.cmTreeView
        Me.tvFilters.FullRowSelect = True
        Me.tvFilters.HideSelection = False
        Me.tvFilters.ImageIndex = -1
        Me.tvFilters.Location = New System.Drawing.Point(4, 8)
        Me.tvFilters.Name = "tvFilters"
        Me.tvFilters.SelectedImageIndex = -1
        Me.tvFilters.Size = New System.Drawing.Size(224, 413)
        Me.tvFilters.Sorted = True
        Me.tvFilters.TabIndex = 0
        Me.tvFilters.Tag = "Please use the context menu"
        '
        'cmTreeView
        '
        Me.cmTreeView.ImageList = Nothing
        Me.cmTreeView.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miViewAll, Me.miViewByCategory, Me.miViewByPlugin, Me.miTreeViewSeperator0, Me.miTreeViewHelp})
        '
        'miViewAll
        '
        Me.miViewAll.CheckStyle = AVSEdit.ExtendedMenuItem.MenuCheckStyle.Radio
        Me.miViewAll.EnglishText = Nothing
        Me.miViewAll.Index = 0
        Me.miViewAll.RadioCheck = True
        Me.miViewAll.Text = "View All"
        '
        'miViewByCategory
        '
        Me.miViewByCategory.CheckStyle = AVSEdit.ExtendedMenuItem.MenuCheckStyle.Radio
        Me.miViewByCategory.EnglishText = Nothing
        Me.miViewByCategory.Index = 1
        Me.miViewByCategory.RadioCheck = True
        Me.miViewByCategory.Text = "View by Category"
        '
        'miViewByPlugin
        '
        Me.miViewByPlugin.CheckStyle = AVSEdit.ExtendedMenuItem.MenuCheckStyle.Radio
        Me.miViewByPlugin.EnglishText = Nothing
        Me.miViewByPlugin.Index = 2
        Me.miViewByPlugin.RadioCheck = True
        Me.miViewByPlugin.Text = "View by Plugin"
        '
        'miTreeViewSeperator0
        '
        Me.miTreeViewSeperator0.EnglishText = Nothing
        Me.miTreeViewSeperator0.Index = 3
        Me.miTreeViewSeperator0.Text = "-"
        '
        'miTreeViewHelp
        '
        Me.miTreeViewHelp.EnglishText = Nothing
        Me.miTreeViewHelp.Index = 4
        Me.miTreeViewHelp.Text = "Help"
        '
        'dcProfiles
        '
        Me.dcProfiles.Controls.Add(Me.tbPreviewProfile)
        Me.dcProfiles.Controls.Add(Me.bPasteProfile)
        Me.dcProfiles.Controls.Add(Me.bLoadProfile)
        Me.dcProfiles.Controls.Add(Me.bSaveSelectionProfile)
        Me.dcProfiles.Controls.Add(Me.bDeleteProfile)
        Me.dcProfiles.Controls.Add(Me.bSaveProfile)
        Me.dcProfiles.Controls.Add(Me.lbProfiles)
        Me.dcProfiles.Controls.Add(Me.tbNameProfile)
        Me.dcProfiles.Guid = New System.Guid("d85e5ff4-b84c-410e-adda-88d176dc411d")
        Me.dcProfiles.Location = New System.Drawing.Point(0, 20)
        Me.dcProfiles.Name = "dcProfiles"
        Me.dcProfiles.Size = New System.Drawing.Size(236, 426)
        Me.dcProfiles.TabImage = CType(resources.GetObject("dcProfiles.TabImage"), System.Drawing.Image)
        Me.dcProfiles.TabIndex = 0
        Me.dcProfiles.Text = "Profiles"
        '
        'tbPreviewProfile
        '
        Me.tbPreviewProfile.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.tbPreviewProfile.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.tbPreviewProfile.Location = New System.Drawing.Point(8, 200)
        Me.tbPreviewProfile.Multiline = True
        Me.tbPreviewProfile.Name = "tbPreviewProfile"
        Me.tbPreviewProfile.ReadOnly = True
        Me.tbPreviewProfile.Size = New System.Drawing.Size(216, 213)
        Me.tbPreviewProfile.TabIndex = 14
        Me.tbPreviewProfile.Text = ""
        Me.tbPreviewProfile.WordWrap = False
        '
        'bPasteProfile
        '
        Me.bPasteProfile.Anchor = System.Windows.Forms.AnchorStyles.Top
        Me.bPasteProfile.Enabled = False
        Me.bPasteProfile.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.bPasteProfile.ImeMode = System.Windows.Forms.ImeMode.NoControl
        Me.bPasteProfile.Location = New System.Drawing.Point(144, 128)
        Me.bPasteProfile.Name = "bPasteProfile"
        Me.bPasteProfile.Size = New System.Drawing.Size(80, 24)
        Me.bPasteProfile.TabIndex = 13
        Me.bPasteProfile.Tag = "Pastes the selected profile at the text selection"
        Me.bPasteProfile.Text = "Paste"
        '
        'bLoadProfile
        '
        Me.bLoadProfile.Anchor = System.Windows.Forms.AnchorStyles.Top
        Me.bLoadProfile.Enabled = False
        Me.bLoadProfile.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.bLoadProfile.ImeMode = System.Windows.Forms.ImeMode.NoControl
        Me.bLoadProfile.Location = New System.Drawing.Point(144, 32)
        Me.bLoadProfile.Name = "bLoadProfile"
        Me.bLoadProfile.Size = New System.Drawing.Size(80, 24)
        Me.bLoadProfile.TabIndex = 12
        Me.bLoadProfile.Tag = "Loads the selected profil"
        Me.bLoadProfile.Text = "Load"
        '
        'bSaveSelectionProfile
        '
        Me.bSaveSelectionProfile.Anchor = System.Windows.Forms.AnchorStyles.Top
        Me.bSaveSelectionProfile.Enabled = False
        Me.bSaveSelectionProfile.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.bSaveSelectionProfile.ImeMode = System.Windows.Forms.ImeMode.NoControl
        Me.bSaveSelectionProfile.Location = New System.Drawing.Point(144, 96)
        Me.bSaveSelectionProfile.Name = "bSaveSelectionProfile"
        Me.bSaveSelectionProfile.Size = New System.Drawing.Size(80, 24)
        Me.bSaveSelectionProfile.TabIndex = 11
        Me.bSaveSelectionProfile.Tag = "Saves the selected text as profile"
        Me.bSaveSelectionProfile.Text = "Save Sel."
        '
        'bDeleteProfile
        '
        Me.bDeleteProfile.Anchor = System.Windows.Forms.AnchorStyles.Top
        Me.bDeleteProfile.Enabled = False
        Me.bDeleteProfile.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.bDeleteProfile.ImeMode = System.Windows.Forms.ImeMode.NoControl
        Me.bDeleteProfile.Location = New System.Drawing.Point(144, 160)
        Me.bDeleteProfile.Name = "bDeleteProfile"
        Me.bDeleteProfile.Size = New System.Drawing.Size(80, 24)
        Me.bDeleteProfile.TabIndex = 10
        Me.bDeleteProfile.Tag = "Deletes the selected profile"
        Me.bDeleteProfile.Text = "Delete"
        '
        'bSaveProfile
        '
        Me.bSaveProfile.Anchor = System.Windows.Forms.AnchorStyles.Top
        Me.bSaveProfile.Enabled = False
        Me.bSaveProfile.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.bSaveProfile.ImeMode = System.Windows.Forms.ImeMode.NoControl
        Me.bSaveProfile.Location = New System.Drawing.Point(144, 64)
        Me.bSaveProfile.Name = "bSaveProfile"
        Me.bSaveProfile.Size = New System.Drawing.Size(80, 24)
        Me.bSaveProfile.TabIndex = 9
        Me.bSaveProfile.Tag = "Saves the script as profile"
        Me.bSaveProfile.Text = "Save"
        '
        'lbProfiles
        '
        Me.lbProfiles.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lbProfiles.Location = New System.Drawing.Point(8, 35)
        Me.lbProfiles.Name = "lbProfiles"
        Me.lbProfiles.Size = New System.Drawing.Size(128, 147)
        Me.lbProfiles.Sorted = True
        Me.lbProfiles.TabIndex = 8
        '
        'tbNameProfile
        '
        Me.tbNameProfile.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.tbNameProfile.Location = New System.Drawing.Point(8, 8)
        Me.tbNameProfile.Name = "tbNameProfile"
        Me.tbNameProfile.Size = New System.Drawing.Size(128, 20)
        Me.tbNameProfile.TabIndex = 2
        Me.tbNameProfile.Text = ""
        '
        'pnRTB
        '
        Me.pnRTB.BackColor = System.Drawing.SystemColors.ControlDark
        Me.pnRTB.Controls.Add(Me.rtb)
        Me.pnRTB.Dock = System.Windows.Forms.DockStyle.Fill
        Me.pnRTB.Location = New System.Drawing.Point(0, 28)
        Me.pnRTB.Name = "pnRTB"
        Me.pnRTB.Size = New System.Drawing.Size(528, 469)
        Me.pnRTB.TabIndex = 34
        '
        'fMain
        '
        Me.AllowDrop = True
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(768, 521)
        Me.Controls.Add(Me.pnRTB)
        Me.Controls.Add(Me.DockHost)
        Me.Controls.Add(Me.sbStatusBar)
        Me.Controls.Add(Me.tbToolBar)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.KeyPreview = True
        Me.Menu = Me.mmMainMenu
        Me.MinimumSize = New System.Drawing.Size(0, 512)
        Me.Name = "fMain"
        Me.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
        Me.DockHost.ResumeLayout(False)
        Me.dp_DockPanel.ResumeLayout(False)
        Me.dcParameters.ResumeLayout(False)
        Me.dcFilters.ResumeLayout(False)
        Me.dcProfiles.ResumeLayout(False)
        Me.pnRTB.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub Undo()
        If mUndo.Count > 3 Then
            mUndo.Pop()
            mUndo.Pop()
            mUndo.Pop()
            rtb.Text = CStr(mUndo.Pop)
        End If
    End Sub

    Private Sub ShowFilterHelp(ByVal fi As Filter)
        If fi Is Nothing Then Exit Sub
        If fi.Plugin.Name <> "Core" Then
            g.ShowHelp("ExternalFilters/" + fi.Helpfile + ".htm")
        Else
            g.ShowHelp("CoreFilters/" + fi.Helpfile + ".htm")
        End If
    End Sub

    Private Function Syntax(ByVal text As String) As String
        Dim x As Integer
        Dim start As Integer
        Dim OldStart As Integer
        Dim rtb As New RichTextBox
        With rtb
            .Text = text
            .SelectAll()
            .SelectionColor = Color.Black
            .Font = g.Settings.Font

            For x = 0 To g.Filters.Count - 1
                start = 0
                OldStart = 0
                While .Find(g.Filters(x).Name, start, RichTextBoxFinds.WholeWord) <> -1
                    .SelectionColor = Color.DarkBlue
                    start = .SelectionStart + .SelectionLength
                    If start <= OldStart Then Exit While
                    OldStart = start
                End While
            Next
            Return .Rtf
        End With
    End Function

    Private Sub miUndo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Undo()
    End Sub

    Private Sub miComment_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Comment()
    End Sub

    Private Function GetPlugin() As Plugin
        Dim Plugin As Plugin
        Dim Filter As Filter
        Dim ToTest As String = rtb.SelectedText
        If Str.Contains(ToTest, "(") Then ToTest = Str.GetLeft(ToTest, "(")
        For Each Plugin In g.Plugins
            For Each Filter In Plugin.Filters
                If Filter.Name = ToTest Then
                    Return Plugin
                End If
            Next
        Next
    End Function

    Private Sub Comment()
        g.BlockPainting(rtb)
        Dim n As Integer
        Dim arr(rtb.Lines.GetUpperBound(0)) As String
        arr = rtb.Lines
        Dim SelStart As Integer = rtb.SelectionStart
        Dim SelLength As Integer = rtb.SelectionLength

        Dim LineStart As Integer = rtb.GetLineFromCharIndex(SelStart)
        Dim LineEnd As Integer = rtb.GetLineFromCharIndex(SelStart + SelLength)
        Dim x As Integer
        For x = 0 To arr.GetUpperBound(0)
            If LineStart <= x And LineEnd >= x Then
                arr(x) = "#" + arr(x)
                n += 1
            End If
        Next
        rtb.Lines = arr
        If SelStart = rtb.Find("#", SelStart, RichTextBoxFinds.None) Then
            rtb.SelectionStart = SelStart
            If SelLength > 0 Then rtb.SelectionLength = SelLength + n Else rtb.SelectionLength = 0
        Else
            rtb.SelectionStart = SelStart + 1
            If SelLength > 0 Then rtb.SelectionLength = SelLength + n - 1
        End If
        g.ContinuePainting(rtb)
    End Sub

    Private Sub UndoComment()
        g.BlockPainting(rtb)
        Dim n As Integer
        Dim arr(rtb.Lines.GetUpperBound(0)) As String
        arr = rtb.Lines
        Dim SelStart As Integer = rtb.SelectionStart
        Dim SelLength As Integer = rtb.SelectionLength
        Dim StartsWithComment As Boolean = rtb.SelectedText.StartsWith("#")
        Dim LineStart As Integer = rtb.GetLineFromCharIndex(SelStart)
        Dim LineEnd As Integer = rtb.GetLineFromCharIndex(SelStart + SelLength)
        Dim x As Integer
        For x = 0 To arr.GetUpperBound(0)
            If LineStart <= x And LineEnd >= x Then
                If arr(x).StartsWith("#") Then
                    arr(x) = arr(x).Substring(1)
                    n += 1
                End If
            End If
        Next
        If n > 0 Then
            rtb.Lines = arr
            If SelStart > rtb.Text.Length Then
                SelStart = rtb.Text.Length
            End If
            If SelStart = rtb.Find("#", SelStart, RichTextBoxFinds.None) Then
                rtb.SelectionStart = SelStart
                If SelLength > 0 Then rtb.SelectionLength = SelLength - n Else rtb.SelectionLength = 0
            Else
                If SelStart > 0 And Not StartsWithComment Then SelStart -= 1
                rtb.SelectionStart = SelStart
                If SelLength > 0 Then SelLength = SelLength - n + 1
                If StartsWithComment Then SelLength -= 1
                rtb.SelectionLength = SelLength
            End If
        End If
        g.ContinuePainting(rtb)
        rtb.Refresh()
    End Sub

    Private Sub miCutContext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miCutContext.Click
        rtb.Cut()
    End Sub

    Private Sub miCopyContext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miCopyContext.Click
        rtb.Copy()
    End Sub

    Private Sub miPasteContext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miPasteContext.Click
        rtb.Paste()
    End Sub

    Private Sub AVS_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.LocationChanged
        CloseCodeCompletion()
        CloseParameterInfo()
    End Sub

    Private Sub bLoadProfile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bLoadProfile.Click
        If Not lbProfiles.SelectedListItem Is Nothing Then rtb.Text = lbProfiles.SelectedListItem.String
        rtb.Focus()
    End Sub

    Private Sub bSaveProfile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bSaveProfile.Click
        If tbNameProfile.Text <> "" And rtb.Text <> "" Then
            Dim s As String = tbNameProfile.Text
            If lbProfiles.FindStringExact(s) > -1 Then
                lbProfiles.Items.RemoveAt(lbProfiles.FindStringExact(s))
            End If
            lbProfiles.Add(New ListItem(s, rtb.Text))
        End If
        rtb.Focus()
    End Sub

    Private Sub bSaveSelectionProfile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bSaveSelectionProfile.Click
        If tbNameProfile.Text <> "" And rtb.SelectedText <> "" Then
            Dim s As String = tbNameProfile.Text
            If lbProfiles.FindStringExact(s) > -1 Then
                lbProfiles.Items.RemoveAt(lbProfiles.FindStringExact(s))
            End If
            lbProfiles.Add(New ListItem(s, rtb.SelectedText))
        End If
        rtb.Focus()
    End Sub

    Private Sub bPasteProfile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bPasteProfile.Click
        If Not lbProfiles.SelectedListItem Is Nothing Then rtb.SelectedText = lbProfiles.SelectedListItem.String
        rtb.Focus()
    End Sub

    Private Sub bDeleteProfile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bDeleteProfile.Click
        lbProfiles.DeleteSelectedItem()
        rtb.Focus()
    End Sub

    Private Sub tbNameProfile_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbNameProfile.TextChanged
        bSaveProfile.Enabled = tbNameProfile.Text <> ""
        bSaveSelectionProfile.Enabled = tbNameProfile.Text <> ""
    End Sub

    Private Sub lbProfiles_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles lbProfiles.DoubleClick
        bLoadProfile.PerformClick()
    End Sub

    Private Sub lbProfiles_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lbProfiles.SelectedIndexChanged
        tbNameProfile.Text = lbProfiles.Text
        bDeleteProfile.Enabled = lbProfiles.SelectedIndex > -1
        bLoadProfile.Enabled = lbProfiles.SelectedIndex > -1
        bPasteProfile.Enabled = lbProfiles.SelectedIndex > -1
        Try
            tbPreviewProfile.Text = Str.FixBreak(CType(lbProfiles.SelectedItem, ListItem).String)
        Catch
            tbPreviewProfile.Text = ""
        End Try
    End Sub

    Private Sub tvFilters_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles tvFilters.MouseUp
        Dim pt As New Point(e.X, e.Y)
        Dim tn As TreeNode = tvFilters.GetNodeAt(pt)
        tvFilters.SelectedNode = tn
    End Sub

    Private Sub tvFilters_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles tvFilters.DoubleClick
        Dim fi As Filter = CType(tvFilters.SelectedNode.Tag, Filter)
        If fi Is Nothing Then Exit Sub
        Dim fc As FilterCollection = GetOverloads(fi)
        If fc.Count > 1 Then
            g.Settings.LastOverloadedFilter(fi.Name) = fc.IndexOf(fi)
        End If
        Dim st As String = GetFilterString(fi)
        If Len(rtb.Text) = rtb.SelectionStart Then st += vbCrLf
        mBlockRTB_SelectionChanged = True
        rtb.SelectedText = st
        rtb.Focus()
        mBlockRTB_SelectionChanged = False
    End Sub

    Private Function GetFilterString(ByVal filter As Filter) As String
        If filter Is Nothing Then Return ""
        Dim pm As Parameter
        Dim st As String = filter.Name + "("
        For Each pm In filter.Parameters
            If Not pm.Optional Then
                Select Case pm.Type
                    Case AviSynthType.string
                        Dim value As String = pm.Default
                        If value = "" Then value = pm.Name
                        st += """" + value + ""","
                    Case Else
                        Dim value As String = pm.Default
                        If value = "" Then value = pm.Name
                        st += value + ","
                End Select
            End If
        Next
        st = st.TrimEnd(","c)
        st += ")"
        Return st
    End Function

    Public Function GetClips() As String()
        Dim sc As New ExtendedStringCollection
        If Not rtb Is Nothing Then
            For Each line As String In rtb.Lines
                line = Str.GetLeft(line, "=").Trim(" "c)
                If line <> "" AndAlso _
                    Not Str.Contains(line, "(") AndAlso _
                    Not sc.Contains(line) Then
                    sc.Add(line)
                End If
            Next
        End If
        Return sc.ToStringArray
    End Function


    Private Sub ComboBoxes_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim cb As ComboBox = CType(sender, ComboBox)
        If cb.SelectedIndex < cb.Items.Count - 1 Then
            cb.SelectedIndex += 1
        ElseIf cb.Items.Count > 0 Then
            cb.SelectedIndex = 0
        End If
    End Sub

    Private Function GetFilterParametersIncluded() As Filter
        Dim SelectedText As String = rtb.SelectedText
        If SelectedText.Length = 0 Then Return Nothing
        If Not SelectedText.EndsWith(")") Then Return Nothing
        Dim filtername As String = Str.GetLeftLast(SelectedText, "(")
        If filtername = "" Then Return Nothing
        If Str.Contains(filtername, "(") Then Return Nothing
        If Str.Contains(filtername, ")") Then Return Nothing
        If Str.Contains(filtername, " ") Then Return Nothing
        Dim fi As Filter
        For Each fi In g.Filters
            If fi.Name.ToLower = filtername.ToLower Then
                Return fi
            End If
        Next
        Return Nothing
    End Function

    Private Function GetFilterFromSelectedText() As Filter
        Dim indexStart As Integer = rtb.SelectionStart
        Dim indexEnd As Integer = rtb.SelectionStart + rtb.SelectionLength
        Dim test, value As String
        value = rtb.SelectedText
        Try
            Do
                indexStart -= 1
                test = rtb.Text.Substring(indexStart, indexEnd - indexStart)
                If Regex.Match(test, "^\w+$").Success Then
                    value = test
                Else
                    Exit Do
                End If
            Loop
        Catch ex As Exception
        End Try
        indexStart += 1
        Try
            Do
                indexEnd += 1
                test = rtb.Text.Substring(indexStart, indexEnd - indexStart)
                If Regex.Match(test, "^\w+$").Success Then
                    value = test
                Else
                    Exit Do
                End If
            Loop
        Catch ex As Exception
        End Try
        For Each i As Filter In g.Filters
            If i.Name.ToLower = value.ToLower Then
                Return i
            End If
        Next
    End Function

    Private Sub tvFilters_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles tvFilters.KeyUp
        If e.KeyCode = Keys.Enter Then
            tvFilters_DoubleClick(Nothing, Nothing)
        End If
    End Sub

    Public Sub rtb_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rtb.TextChanged
        Static IsActive As Boolean = True
        If IsActive Then
            IsActive = False
            Static old As String
            If old <> rtb.Text Then mUndo.Push(old)
            old = rtb.Text
            mUndo.Push(rtb.Text)
            Dim SelStart As Integer = rtb.SelectionStart
            Dim SelLength As Integer = rtb.SelectionLength
            rtb.Update()
            rtb.Rtf = Syntax(rtb.Text)
            If SelStart = -1 Then SelStart = rtb.TextLength
            If SelLength = -1 Then SelLength = 0
            rtb.SelectionStart = SelStart
            rtb.SelectionLength = SelLength
            tbbSave.Enabled = mChanged <> rtb.Text
            miSave.Enabled = mChanged <> rtb.Text
        End If
        IsActive = True
    End Sub

    Private Sub rtb_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles rtb.KeyDown
        If Not mFormCompletion Is Nothing Then
            If e.KeyData = Keys.Up Then
                e.Handled = True
                If mFormCompletion.lb.SelectedIndex > 0 Then
                    mFormCompletion.lb.SelectedIndex -= 1
                End If
            ElseIf e.KeyData = Keys.Down Then
                e.Handled = True
                If mFormCompletion.lb.SelectedIndex < mFormCompletion.lb.Items.Count - 1 Then
                    mFormCompletion.lb.SelectedIndex += 1
                End If
            ElseIf e.KeyData = Keys.Enter Then
                Dim fi As Filter = CType(mFormCompletion.lb.SelectedItem, Filter)
                If Not fi Is Nothing Then
                    e.Handled = True

                    Dim fc As FilterCollection = GetOverloads(fi)

                    If fc.Count > 1 Then
                        g.Settings.LastOverloadedFilter(fi.Name) = fc.IndexOf(fi)
                    End If

                    rtb.SelectionStart -= mFormCompletion.mText.Length
                    rtb.SelectionLength = mFormCompletion.mText.Length
                    rtb.SelectedText = GetFilterString(fi)
                End If
            End If
        Else
            If e.KeyCode = Keys.OemPeriod Then
                If rtb.SelectionStart > 2 AndAlso Regex.Match( _
                    rtb.Text.Substring(rtb.SelectionStart - 1, 1), "[a-zA-Z\)]").Success Then

                    ShowCodeCompletion(7)
                    mFormCompletion.mText = ""
                    mFormCompletion.SelectItem()
                End If
            End If
        End If

        If e.KeyCode <> Keys.Up AndAlso _
            e.KeyCode <> Keys.Down AndAlso _
            e.KeyCode <> Keys.Left AndAlso _
            e.KeyCode <> Keys.Right Then

            InvokeParameterInfo()
        End If
    End Sub

    Private Sub rtb_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles rtb.KeyPress
        If Not mFormCompletion Is Nothing Then
            If e.KeyChar = "("c Then
                Dim fi As Filter = CType(mFormCompletion.lb.SelectedItem, Filter)
                If Not fi Is Nothing Then
                    e.Handled = True
                    rtb.SelectionStart -= mFormCompletion.mText.Length
                    rtb.SelectionLength = mFormCompletion.mText.Length
                    rtb.SelectedText = fi.Name + "("
                    CloseCodeCompletion()
                    ShowParameterInfo(fi, rtb.PointToScreen(rtb.GetPositionFromCharIndex(rtb.SelectionStart)))
                    mFormParameterInfo.Left = mFormParameterInfo.Left - 5
                End If
            End If
        End If
        If e.KeyChar = " "c AndAlso Control.ModifierKeys = Keys.Control Then
            e.Handled = True
            ShowCodeCompletion(0)
        ElseIf e.KeyChar = "("c Then
            Dim f As Filter
            For Each filter As Filter In g.Filters
                If rtb.SelectionStart > filter.Name.Length - 1 AndAlso rtb.Text.Substring(rtb.SelectionStart - filter.Name.Length, filter.Name.Length).ToLower = filter.Name.ToLower Then
                    If f Is Nothing OrElse f.Name.Length < filter.Name.Length Then
                        f = filter
                    End If
                End If
            Next
            If Not f Is Nothing Then
                ShowParameterInfo(f, rtb.PointToScreen(rtb.GetPositionFromCharIndex(rtb.SelectionStart)))
            End If
        End If
    End Sub

    Private Sub rtb_KeyUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles rtb.KeyUp
        Dim t As String = rtb.Text
        t = t.Substring(0, rtb.SelectionStart)
        t = Str.FixBreak(t)
        If Str.Contains(t, vbCrLf) Then t = Str.GetRightLast(t, vbCrLf)

        If Not mFormParameterInfo Is Nothing AndAlso _
            Not Str.Contains(t.ToLower, _ParameterInfoFilter.Name.ToLower() + "(") OrElse _
            Str.Contains(Str.GetRightLast(t, "("), ")") Then

            CloseParameterInfo()
        End If

        CheckForUserFunctions()
    End Sub

    Private Sub ShowCodeCompletion(ByVal offset As Integer)
        CloseCodeCompletion()
        mFormCompletion = New fCompletion(rtb)
        mFormCompletion.Owner = Me
        Dim pos As Point = rtb.PointToScreen(rtb.GetPositionFromCharIndex(rtb.SelectionStart))

        If offset <> 0 Then
            mFormCompletion.Left = pos.X + offset
        Else
            mFormCompletion.Left = pos.X
        End If

        mFormCompletion.Top = pos.Y + rtb.Font.Height
        mFormCompletion.Refresh()
        mFormCompletion.Show()
        Activate()
    End Sub

    Public Sub CloseCodeCompletion()
        Try
            mFormCompletion.Close()
            mFormCompletion.Dispose()
            mFormCompletion = Nothing
        Catch
        End Try
    End Sub

    Public Sub CloseParameterInfo()
        Try
            mFormParameterInfo.Close()
            mFormParameterInfo.Dispose()
            mFormParameterInfo = Nothing
        Catch
        End Try
    End Sub

    Private Sub rtb_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles rtb.MouseDown
        CloseCodeCompletion()
        CloseParameterInfo()
    End Sub

    Private Sub miCommentContext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miCommentContext.Click
        Comment()
    End Sub

    Private Sub miUncommentContext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miUndoCommentContext.Click
        UndoComment()
    End Sub

    Private Sub miExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miExit.Click
        Close()
    End Sub

    Private Sub miCopy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miCopy.Click
        rtb.Copy()
    End Sub

    Private Sub miCut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miCut.Click
        rtb.Cut()
    End Sub

    Private Sub miPaste_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miPaste.Click
        rtb.Paste()
        CheckForUserFunctions()
    End Sub

    Private Sub miUndo_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miUndo.Click
        Undo()
    End Sub

    Private Sub miComment_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miComment.Click
        Comment()
    End Sub

    Private Sub miUndoComment_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miUndoComment.Click
        UndoComment()
    End Sub

    Private Sub miForum_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        g.Run("Forum", "http://www.planetdvb.net/board/")
    End Sub

    Private Sub bFilterHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bFilterHelp.Click
        Try
            ShowFilterHelp(GetLastFilter(GetOverloads(GetFilterParametersIncluded())))
            rtb.Focus()
        Catch ex As Exception
        End Try
    End Sub

    Private Sub dp_DockPanel_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles dp_DockPanel.Resize
        bFilterPreview.Left = pgParameters.Left
        bFilterEditor.Left = pgParameters.Left
        bFilterEditor.Width = pgParameters.Width
        bFilterPreview.Width = CInt(pgParameters.Width / 2 - 2)
        bFilterHelp.Left = pgParameters.Left + bFilterPreview.Width + 4
        bFilterHelp.Width = bFilterPreview.Width
    End Sub

    Private Sub bFilterPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bFilterPreview.Click
        Dim script As String = Str.GetLeft(rtb.Text, rtb.SelectionStart + rtb.SelectionLength).TrimEnd(Chr(10))
        Dim lines As String() = Split(script, Chr(10))
        Dim lastLine As String = lines(lines.Length - 1)
        Dim test As String = Str.GetLeft(lastLine, "=")
        If test <> "" AndAlso Not Str.Contains(test, "(") Then
            lastLine = Str.GetRight(lastLine, "=")
        End If
        test = Str.GetLeftLast(lastLine, rtb.SelectedText)
        If test.EndsWith("+") Or test.EndsWith("+ ") Then
            lastLine = rtb.SelectedText
        End If
        lines(lines.Length - 1) = lastLine
        script = Join(lines, Chr(10))
        Dim f As New fPreview(script)
        f.Owner = Me
        f.Show()
        rtb.Focus()
    End Sub

    Private Sub miFilterList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miFilterList.Click
        ShowCodeCompletion(7)
    End Sub

    Private Sub PopulateFilters(ByVal filters As TreeNode())
        tvFilters.Nodes.Clear()
        tvFilters.BeginUpdate()
        tvFilters.Nodes.AddRange(filters)
        tvFilters.ImageList = il16
        tvFilters.EndUpdate()
    End Sub

    Private Sub miViewAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miViewAll.Click
        PopulateFilters(g.FilterTreeNodesAll)
        g.Settings.FilterView = cmTreeView.GetIndexOfCheckedRadioSubItem
    End Sub

    Private Sub miViewByCategory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miViewByCategory.Click
        PopulateFilters(g.FilterTreeNodesByCategory)
        g.Settings.FilterView = cmTreeView.GetIndexOfCheckedRadioSubItem
    End Sub

    Private Sub miViewByPlugin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miViewByPlugin.Click
        PopulateFilters(g.FilterTreeNodesByPlugin)
        g.Settings.FilterView = cmTreeView.GetIndexOfCheckedRadioSubItem
    End Sub

    Private Sub miTreeViewHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miTreeViewHelp.Click
        Try
            Dim tn As TreeNode = tvFilters.SelectedNode
            Dim fi As Filter = CType(tn.Tag, Filter)
            ShowFilterHelp(fi)
        Catch
        End Try
    End Sub

    Private Sub miNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miNew.Click
        If SaveNotCanceled() Then
            rtb.Text = ""
            mChanged = rtb.Text
            mPath = ""
            sbStatusBar.Text = mPath
        End If
    End Sub

    Private Sub miOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miOpen.Click
        Update()
        If SaveNotCanceled() Then
            Dim f As New OpenFileDialog
            f.Filter = g.GetResource("AviSynth Scripts") + " (*.avs)|*.avs|" + g.GetResource("All Files") + " (*.*)|*.*"
            f.ShowDialog()
            If f.FileName <> "" Then
                Open(f.FileName)
            End If
        End If
    End Sub

    Private Sub Open(ByVal path As String)
        Dim st As New Str
        st.AddFile(path)
        rtb.Text = st.Text
        mChanged = rtb.Text
        mPath = path
        sbStatusBar.Text = mPath
        RecentFiles(mPath)
        CheckForUserFunctions()
        rtb_TextChanged(Nothing, Nothing)
    End Sub

    Private Sub miSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miSave.Click
        Save()
        rtb_TextChanged(Nothing, Nothing)
    End Sub

    Private Sub miSaveAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miSaveAs.Click
        Dim f As New SaveFileDialog
        f.Filter = g.GetResource("AviSynth Scripts") + " (*.avs)|*.avs|" + g.GetResource("All Files") + " (*.*)|*.*"
        f.ShowDialog()
        If f.FileName <> "" Then
            Save(f.FileName)
            rtb_TextChanged(Nothing, Nothing)
        End If
    End Sub

    Private Function Save(ByVal path As String) As Boolean
        If path <> "" Then
            Dim str As New Str(rtb.Text)
            str.Text = str.FixBreak()
            str.Save(path)
            mChanged = str.Text
            mPath = path
            sbStatusBar.Text = mPath
            RecentFiles(mPath)
        End If
    End Function

    Private Function Save() As Boolean
        If mPath = "" Then
            Dim f As New SaveFileDialog
            f.Filter = g.GetResource("AviSynth Scripts") + " (*.avs)|*.avs|" + g.GetResource("All Files") + " (*.*)|*.*"
            f.ShowDialog()
            mPath = f.FileName
        End If
        If mPath <> "" Then
            Save(mPath)
            Return True
        End If
    End Function

    Private Function SaveNotCanceled() As Boolean
        If mChanged <> rtb.Text Then
            Select Case MessageBox.Show(g.GetResource("Save Changes?"), g.GetResource("Save"), MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question)
                Case DialogResult.Cancel
                    Return False
                Case DialogResult.Yes
                    Return Save()
            End Select
        End If
        Return True
    End Function

    Private Sub fMain_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        If SaveNotCanceled() Then
            g.Settings.Profiles = lbProfiles.GetObjectArray
            Settings.Serialize(g.Settings, mSettingsFile)
        Else
            e.Cancel = True
        End If
    End Sub

    Private Sub fMain_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Activated
        Static done As Boolean
        If Not done Then
            done = True
            Update()

            g.FormMain = Me

            miCopy.Enabled = False
            miCut.Enabled = False
            miCopyContext.Enabled = False
            miCutContext.Enabled = False
            tbbCopy.Enabled = False
            tbbCut.Enabled = False

            bFilterPreview.Anchor = AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Bottom
            bFilterHelp.Anchor = AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Bottom
            bLoadProfile.Anchor = AnchorStyles.Right Or AnchorStyles.Top
            bSaveProfile.Anchor = AnchorStyles.Right Or AnchorStyles.Top
            bSaveSelectionProfile.Anchor = AnchorStyles.Right Or AnchorStyles.Top
            bPasteProfile.Anchor = AnchorStyles.Right Or AnchorStyles.Top
            bDeleteProfile.Anchor = AnchorStyles.Right Or AnchorStyles.Top

            dp_DockPanel.SelectedTab = dcParameters

            bFilterPreview.Anchor = AnchorStyles.Bottom
            bFilterHelp.Anchor = AnchorStyles.Bottom
            bFilterEditor.Anchor = AnchorStyles.Bottom

            mEditorSignaturs.Add(New EditorSignatur(g.GetResource("Crop Editor"), New String() {"clip", "left", "top", "right", "bottom"}, GetType(fCropEditor)))
            mEditorSignaturs.Add(New EditorSignatur(g.GetResource("Resize Editor"), New String() {"clip", "target_width", "target_height"}, GetType(fResizeEditor)))

            lbProfiles.Items.AddRange(g.Settings.Profiles)

            ExtendedMenuItem.Init(Me, mmMainMenu, g.Settings.KeyCombinations)

            RecentFiles("")
            For Each path As String In Dir.GetFilePaths(Paths.GetApplicationDir + "languages\")
                path = IO.Path.GetFileNameWithoutExtension(path)
                If path <> "Last modified" Then
                    Dim mi As New ExtendedMenuItem(path, ExtendedMenuItem.MenuCheckStyle.Radio, AddressOf Language_Clicked)
                    mi.ShowShortcut = False
                    If g.Settings.Language = mi.Text Then
                        mi.Checked = True
                    End If
                    miLanguage.MenuItems.Add(mi)
                End If
            Next

            Dim foundNew As Boolean

            For Each i As String In Directory.GetFiles(Paths.GetPluginDir, "*.avs")
                Dim str As New Str
                str.AddFile(i)
                If AddUserFunctions(str.Text) Then
                    foundNew = True
                End If
            Next

            If foundNew Then
                PopulateFilterTreeNodes()
                cmTreeView.MenuItems(g.Settings.FilterView).PerformClick()
            End If

            RichTextBoxHelper.DisableAutoSelection(rtb)
            rtb_TextChanged(Nothing, Nothing)
            cmTreeView.MenuItems(g.Settings.FilterView).PerformClick()
            Registry.Write(Registry.Root.CurrentUser, "Software\Microsoft\Windows\ShellNoRoam\MUICache", Application.ExecutablePath, Application.ProductName) ''legacy
            rtb.Focus()
        End If
    End Sub

    Private Sub Language_Clicked(ByVal sender As Object, ByVal e As EventArgs)
        g.Settings.Language = CType(sender, MenuItem).Text
        Msg.Show(g.GetResource("The changes will be active on next startup"), g.GetResource("Restart"), MessageBoxIcon.Information)
    End Sub

    Private Sub PopulateFilterTreeNodes()
        Dim treeNodesByCategory As New ArrayList
        Dim pl As Plugin
        Dim fi As Filter
        Dim categories As New Hashtable
        Dim plugins As New Hashtable
        Dim categoryNode, pluginTreeNode, filterTreeNode As TreeNode
        For Each fi In g.Filters
            If fi.Category = "" Then fi.Category = "???"
            If Not categories.ContainsKey(fi.Category) Then
                categoryNode = New TreeNode(fi.Category)
                categoryNode.ImageIndex = 0
                categoryNode.SelectedImageIndex = 0
                categories.Add(fi.Category, categoryNode)
                treeNodesByCategory.Add(categoryNode)
            End If
            filterTreeNode = New TreeNode
            If fi.Plugin.Name = "Core" Then
                filterTreeNode.ImageIndex = 2
                filterTreeNode.SelectedImageIndex = 2
            Else
                filterTreeNode.ImageIndex = 16
                filterTreeNode.SelectedImageIndex = 16
            End If
            filterTreeNode.Tag = fi
            filterTreeNode.Text = fi.Name
            CType(categories(fi.Category), TreeNode).Nodes.Add(filterTreeNode)
        Next
        g.FilterTreeNodesByCategory = CType(treeNodesByCategory.ToArray(GetType(TreeNode)), TreeNode())
        Dim treeNodesByPlugin As New ArrayList
        For Each fi In g.Filters
            If Not plugins.ContainsKey(fi.Plugin.Name) Then
                pluginTreeNode = New TreeNode
                pluginTreeNode.ImageIndex = 0
                pluginTreeNode.SelectedImageIndex = 0
                pluginTreeNode.Text = fi.Plugin.Name
                plugins.Add(fi.Plugin.Name, pluginTreeNode)
                treeNodesByPlugin.Add(pluginTreeNode)
            End If
            filterTreeNode = New TreeNode
            If fi.Plugin.Name = "Core" Then
                filterTreeNode.ImageIndex = 2
                filterTreeNode.SelectedImageIndex = 2
            Else
                filterTreeNode.ImageIndex = 16
                filterTreeNode.SelectedImageIndex = 16
            End If
            filterTreeNode.Tag = fi
            filterTreeNode.Text = fi.Name
            CType(plugins(fi.Plugin.Name), TreeNode).Nodes.Add(filterTreeNode)
        Next
        g.FilterTreeNodesByPlugin = CType(treeNodesByPlugin.ToArray(GetType(TreeNode)), TreeNode())
        Dim treeNodesAll As New ArrayList
        For Each fi In g.Filters
            filterTreeNode = New TreeNode
            If fi.Plugin.Name = "Core" Then
                filterTreeNode.ImageIndex = 2
                filterTreeNode.SelectedImageIndex = 2
            Else
                filterTreeNode.ImageIndex = 16
                filterTreeNode.SelectedImageIndex = 16
            End If
            filterTreeNode.Tag = fi
            filterTreeNode.Text = fi.Name
            treeNodesAll.Add(filterTreeNode)
        Next
        g.FilterTreeNodesAll = CType(treeNodesAll.ToArray(GetType(TreeNode)), TreeNode())
    End Sub

    Public Sub LoadFilters()
        g.Filters.Clear()
        g.Plugins.Clear()
        For Each path As String In Dir.GetFilePaths(Paths.GetApplicationDir + "filters", "*.xml")
            LoadFilter11(path)
        Next
        PopulateFilterTreeNodes()
    End Sub

    Public Sub LoadFilter11(ByVal path As String)
        Dim d As New Xml.XmlDocument
        d.Load(path)
        If Not Str.Contains(d.InnerXml, "AviSynth plugin description version 1.1") Then
            LoadFilter10(path)
            Exit Sub
        End If
        Dim plugin As New Plugin
        g.Plugins.Add(plugin)
        plugin.Name = d.DocumentElement.GetAttribute("name")
        plugin.Description = d.DocumentElement.SelectSingleNode("description").InnerText
        For Each filterNode As Xml.XmlNode In d.DocumentElement.SelectSingleNode("filters").ChildNodes
            Dim filter As New Filter
            g.Filters.Add(filter)
            plugin.Filters.Add(filter)
            filter.Plugin = plugin
            filter.Name = filterNode.Attributes.ItemOf("name").Value
            filter.Type = GetAviSynthType(filterNode.Attributes.ItemOf("type").Value)
            filter.Category = filterNode.Attributes.ItemOf("category").Value
            filter.Helpfile = filterNode.Attributes.ItemOf("helpfile").Value
            filter.Description = filterNode.SelectSingleNode("description").InnerText
            For Each colorspace As Xml.XmlNode In filterNode.SelectSingleNode("colorspaces").ChildNodes
                filter.Colorspaces.Add(colorspace.InnerText)
            Next
            For Each paramNode As Xml.XmlNode In filterNode.SelectSingleNode("parameters").ChildNodes
                Dim param As New Parameter
                filter.Parameters.Add(param)
                param.Name = paramNode.Attributes.ItemOf("name").Value
                param.Type = GetAviSynthType(paramNode.Attributes.ItemOf("type").Value)
                param.Default = paramNode.Attributes.ItemOf("default").Value
                param.Max = Convert.ToDouble(paramNode.Attributes.ItemOf("max").Value, NumberFormatInfo.InvariantInfo)
                param.Min = Convert.ToDouble(paramNode.Attributes.ItemOf("min").Value, NumberFormatInfo.InvariantInfo)
                param.Step = Convert.ToDouble(paramNode.Attributes.ItemOf("step").Value, NumberFormatInfo.InvariantInfo)
                param.Optional = paramNode.Attributes.ItemOf("optional").Value.ToLower = "true"
                param.ParameterList = XMLNodeHelper.GetBooleanAttribute(paramNode, "paramList")
                param.Description = paramNode.SelectSingleNode("description").InnerText
                For Each item As Xml.XmlNode In paramNode.SelectSingleNode("items").ChildNodes
                    param.Items.Add(item.InnerText)
                Next
            Next
        Next
    End Sub

    Public Sub LoadFilter10(ByVal path As String) 'old
        Dim doc As New Xml.XmlDocument
        Dim nav As Xml.XPath.XPathNavigator
        Dim PluginIterator, FiltersIterator, FilterIterator, ParametersIterator, ParameterIterator, ItemsIterator As Xml.XPath.XPathNodeIterator
        Dim Plugin As Plugin
        Dim items As New ExtendedStringCollection
        Dim Parameter As Parameter

        doc.Load(path)
        PluginIterator = doc.DocumentElement.CreateNavigator.SelectChildren(Xml.XPath.XPathNodeType.All)
        Plugin = New Plugin
        While PluginIterator.MoveNext
            If PluginIterator.Current.Name = "Name" Then Plugin.Name = PluginIterator.Current.Value
            If PluginIterator.Current.Name = "Description" Then Plugin.Description = PluginIterator.Current.Value
            If PluginIterator.Current.Name = "Filters" Then
                FiltersIterator = PluginIterator.Current.SelectChildren(Xml.XPath.XPathNodeType.All)
                While FiltersIterator.MoveNext
                    Dim filter As New Filter
                    filter.Plugin = Plugin
                    FilterIterator = FiltersIterator.Current.SelectChildren(Xml.XPath.XPathNodeType.All)
                    While FilterIterator.MoveNext
                        If FilterIterator.Current.Name = "Category" Then filter.Category = FilterIterator.Current.Value
                        If FilterIterator.Current.Name = "Description" Then filter.Description = FilterIterator.Current.Value
                        If FilterIterator.Current.Name = "Helpfile" Then filter.Helpfile = FilterIterator.Current.Value
                        If FilterIterator.Current.Name = "Name" Then filter.Name = FilterIterator.Current.Value
                        If FilterIterator.Current.Name = "Type" Then
                            Select Case FilterIterator.Current.Value
                                Case "int"
                                    filter.Type = AviSynthType.int
                                Case "bool"
                                    filter.Type = AviSynthType.bool
                                Case "string"
                                    filter.Type = AviSynthType.string
                                Case "float"
                                    filter.Type = AviSynthType.float
                                Case "clip"
                                    filter.Type = AviSynthType.clip
                                Case "variant"
                                    filter.Type = AviSynthType.variant
                            End Select
                        End If
                        If FilterIterator.Current.Name = "Colorspaces" Then
                            items.Clear()
                            ItemsIterator = FilterIterator.Current.SelectChildren(Xml.XPath.XPathNodeType.All)
                            While ItemsIterator.MoveNext
                                If ItemsIterator.Current.Value <> "" Then items.Add(ItemsIterator.Current.Value)
                            End While
                            filter.Colorspaces.SetItems(items.ToStringArray)
                        End If
                        If FilterIterator.Current.Name = "Parameters" Then
                            ParametersIterator = FilterIterator.Current.SelectChildren(Xml.XPath.XPathNodeType.All)
                            While ParametersIterator.MoveNext
                                Parameter = New Parameter
                                ParameterIterator = ParametersIterator.Current.SelectChildren(Xml.XPath.XPathNodeType.All)
                                While ParameterIterator.MoveNext
                                    If ParameterIterator.Current.Name = "Default" Then Parameter.Default = ParameterIterator.Current.Value
                                    If ParameterIterator.Current.Name = "Description" Then Parameter.Description = ParameterIterator.Current.Value
                                    If ParameterIterator.Current.Name = "Items" Then
                                        items.Clear()
                                        ItemsIterator = ParameterIterator.Current.SelectChildren(Xml.XPath.XPathNodeType.All)
                                        While ItemsIterator.MoveNext
                                            If ItemsIterator.Current.Value <> "" Then items.Add(ItemsIterator.Current.Value)
                                        End While
                                        Parameter.Items.SetItems(items.ToStringArray)
                                    End If
                                    If ParameterIterator.Current.Name = "Max" Then Parameter.Max = g.GetInteger(ParameterIterator.Current.Value)
                                    If ParameterIterator.Current.Name = "Min" Then Parameter.Min = g.GetInteger(ParameterIterator.Current.Value)
                                    If ParameterIterator.Current.Name = "Name" Then Parameter.Name = ParameterIterator.Current.Value
                                    If ParameterIterator.Current.Name = "Optional" Then Parameter.Optional = CBool(ParameterIterator.Current.Value)
                                    If ParameterIterator.Current.Name = "Step" Then Parameter.Step = g.GetInteger(ParameterIterator.Current.Value)
                                    If ParameterIterator.Current.Name = "Type" Then
                                        Select Case ParameterIterator.Current.Value
                                            Case "int"
                                                Parameter.Type = AviSynthType.int
                                            Case "bool"
                                                Parameter.Type = AviSynthType.bool
                                            Case "string"
                                                Parameter.Type = AviSynthType.string
                                            Case "float"
                                                Parameter.Type = AviSynthType.float
                                            Case "clip"
                                                Parameter.Type = AviSynthType.clip
                                            Case "variant"
                                                Parameter.Type = AviSynthType.variant
                                        End Select
                                    End If
                                End While
                                filter.Parameters.Add(Parameter)
                            End While
                        End If
                    End While
                    g.Filters.Add(filter)
                    Plugin.Filters.Add(filter)
                End While
            End If
        End While
        g.Plugins.Add(Plugin)
    End Sub

    Private Function GetAviSynthType(ByVal value As String) As AviSynthType
        Select Case value
            Case "int"
                Return AviSynthType.int
            Case "bool"
                Return AviSynthType.bool
            Case "string"
                Return AviSynthType.string
            Case "float"
                Return AviSynthType.float
            Case "clip"
                Return AviSynthType.clip
            Case "variant"
                Return AviSynthType.variant
        End Select
    End Function

    <System.STAThread()> _
    Public Shared Sub Main()
        Application.EnableVisualStyles()
        Application.DoEvents() ''borked
        Application.Run(New fMain)
    End Sub

    Public Sub RecentFiles(ByVal path As String)
        If path <> "" Then
            g.Settings.RecentFiles.Remove(path)
            g.Settings.RecentFiles.Insert(0, path)
        End If
        If g.Settings.RecentFiles.Count > 9 Then g.Settings.RecentFiles.RemoveAt(9)
        miRecentFiles.MenuItems.Clear()
        For Each path In g.Settings.RecentFiles
            If File.Exists(path) Then
                Dim mi As New MenuItem(path, AddressOf RecentFiles_Click)
                mi.ShowShortcut = False
                miRecentFiles.MenuItems.Add(mi)
            End If
        Next
    End Sub

    Private Sub RecentFiles_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If SaveNotCanceled() Then
            Open(CType(sender, MenuItem).Text)
        End If
    End Sub

    Public Shared Function SplitQuotes(ByVal items As String(), ByVal seperator As String) As String
        Dim Item As String
        For Each Item In items
            SplitQuotes += """" + Item + """"
        Next
        Return Replace(SplitQuotes, """""", """" + seperator + """")
    End Function

    Private Sub miOpenFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miOpenFile.Click
        Dim f As New OpenFileDialog
        f.Multiselect = True
        f.ShowDialog()
        If f.FileName <> "" Then
            If f.FileNames.Length > 1 Then
                rtb.SelectedText = SplitQuotes(f.FileNames, ",")
            Else
                rtb.SelectedText = f.FileName
            End If
        End If
    End Sub

    Private Sub miGPL_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miGPL.Click
        Dim f As New fInfo(Paths.GetApplicationDir + "info\GPL License.txt")
        f.rtb.ScrollBars = RichTextBoxScrollBars.Vertical
        f.Height = f.Width - 50
        f.ShowDialog()
    End Sub

    Private Sub miInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miInfo.Click
        Update()
        Dim f As New fInfo(Paths.GetApplicationDir + "info\Info.txt")
        f.ShowDialog()
    End Sub

    Private Sub miOpenPluginDir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miOpenPluginDir.Click
        g.Run("plugin dir", Paths.GetPluginDir)
    End Sub

    Private Sub miOptions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miOptions.Click
        Dim f As New fOptions
        f.ShowDialog()
    End Sub

    Private Sub miHelpfile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miHelpfile.Click
        Dim f As Filter = GetFilterFromSelectedText()
        If f Is Nothing Then
            f = GetFilterParametersIncluded()
        End If
        If f Is Nothing Then
            g.ShowHelp("")
        Else
            f = GetLastFilter(GetOverloads(f))
            ShowFilterHelp(f)
        End If
    End Sub

    Private Sub fMain_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles MyBase.DragEnter
        e.Effect = DragDropEffects.Copy
    End Sub

    Private Sub fMain_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles MyBase.DragDrop
        For Each path As String In CType(e.Data.GetData(DataFormats.FileDrop), String())
            If SaveNotCanceled() AndAlso _
               IO.Path.GetExtension(path).ToLower = ".avs" AndAlso _
                File.Exists(path) Then
                Open(path)
            Else
                rtb.SelectedText = path
            End If
            Exit Sub
        Next
    End Sub

    Private Sub rtb_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles rtb.DragEnter
        fMain_DragEnter(sender, e)
    End Sub

    Private Sub rtb_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles rtb.DragDrop
        fMain_DragDrop(sender, e)
    End Sub

    Private Sub miPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miPreview.Click
        If Str.Contains(rtb.SelectedText.ToLower, "trim(") Then
            Dim hash As New Hashtable
            For Each fn As String In Split(rtb.SelectedText.ToLower.Replace(" ", "").Replace(Chr(10), "").Replace(Chr(13), "").Replace("\", ""), "+")
                If Regex.Match(fn, "^trim\(\d+,\d+\)$").Success Then
                    Dim trim As String() = Split(Regex.Match(fn, "\d+,\d+").Value, ",")
                    hash(CInt(trim(0))) = CInt(trim(1))
                End If
            Next
            Dim f As New fPreview(g.GetScriptBeforeSelection)
            f.Owner = Me
            f.mTrim = hash
            f.Show()
        Else
            Dim f As New fPreview(rtb.Text)
            f.Owner = Me
            f.Show()
        End If
    End Sub

    Private Sub miExternalPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miExternalPreview.Click
        Dim st As New Str(rtb.Text)
        st.Save(Paths.GetApplicationDir + "temp\Preview.avs")
        g.Run("External Preview", g.Settings.ExternalPreview + " """ + Paths.GetApplicationDir + "temp\Preview.avs""")
    End Sub

    Private Sub EnableEditorButton(ByVal filter As Filter)
        For Each i As EditorSignatur In mEditorSignaturs
            If IsEditor(filter, i.Signatur) Then
                bFilterEditor.Visible = True
                bFilterEditor.Text = i.Name
                Exit For
            End If
        Next
    End Sub

    Private Function IsEditor(ByVal filter As Filter, ByVal signatur As String()) As Boolean
        If filter.Parameters.Count >= signatur.Length Then
            For x As Integer = 0 To signatur.Length - 1
                Dim param As String = signatur(x)
                If param <> filter.Parameters(x).Name Then
                    Return False
                End If
            Next
            Return True
        End If
    End Function

    Private Sub bFilterEditor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bFilterEditor.Click
        Dim fi As Filter = GetFilterParametersIncluded()
        For Each i As EditorSignatur In mEditorSignaturs
            If IsEditor(fi, i.Signatur) Then
                Dim editor As IFilterEditor = CType(Reflection.Assembly. _
                    GetExecutingAssembly.CreateInstance(i.Editor.FullName), IFilterEditor)
                editor.Signatur = i
                editor.ShowEditor()
                Exit Sub
            End If
        Next
        rtb.Focus()
    End Sub

    Private Sub miChangelog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miChangelog.Click
        Update()
        Dim f As New fInfo(Paths.GetApplicationDir + "info\Changelog.txt")
        f.ShowDialog()
    End Sub

    Private Sub fMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        LoadFilters()
        rtb.Font = g.Settings.Font
        If Environment.GetCommandLineArgs.Length > 1 Then
            Open(Environment.GetCommandLineArgs(1))
        End If
    End Sub

    Private Sub ShowParameterInfo(ByVal f As Filter, ByVal position As Point)
        _ParameterInfoFilter = f
        mFormParameterInfo = New fTip
        mFormParameterInfo.Owner = Me
        mFormParameterInfo.Left = position.X + 5
        mFormParameterInfo.Top = position.Y + rtb.Font.Height
        mFormParameterInfo.rtb.Text = g.GetParameterText(f)
        mFormParameterInfo.AdjustSize()
        mFormParameterInfo.Show()
        Activate()
    End Sub

    Private Sub InvokeParameterInfo()
        If mFormParameterInfo Is Nothing Then
            Dim s As String = ""
            Dim fc As FilterCollection
            Dim lastIndex As Integer

            Dim Start As Integer = rtb.SelectionStart

            For i As Integer = 0 To Start
                s = rtb.Text.Substring(Start - i, 0 + i)
                If Str.Contains(s, Chr(10)) OrElse Str.Contains(s, ")") Then
                    s = s.Substring(1)
                    Exit Sub
                End If

                For i2 As Integer = 0 To g.Filters.Count - 1
                    If s.ToLower.StartsWith(g.Filters(i2).Name.ToLower + "(") Then
                        If fc Is Nothing Then
                            fc = New FilterCollection
                        End If
                        fc.Add(g.Filters(i2))
                        lastIndex = i
                    End If
                Next

                If Not fc Is Nothing Then
                    Dim f As Filter = GetLastFilter(fc)
                    ShowParameterInfo(f, rtb.PointToScreen(rtb.GetPositionFromCharIndex(Start - lastIndex + (f.Name.ToLower + "(").Length)))
                    mFormParameterInfo.Left -= 7
                    Exit For
                End If
            Next
        End If
    End Sub

    Private Sub rtb_SelectionChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rtb.SelectionChanged
        If mBlockRTB_SelectionChanged Then Exit Sub

        miCopy.Enabled = rtb.SelectedText <> ""
        miCut.Enabled = rtb.SelectedText <> ""
        miCopyContext.Enabled = rtb.SelectedText <> ""
        miCutContext.Enabled = rtb.SelectedText <> ""
        tbbCopy.Enabled = rtb.SelectedText <> ""
        tbbCut.Enabled = rtb.SelectedText <> ""

        If SetParameterGrid() Then
            dp_DockPanel.SelectedTab = dcParameters
            bFilterPreview.Visible = True
            bFilterHelp.Visible = True
        Else
            bFilterPreview.Visible = False
            bFilterHelp.Visible = False
            bFilterEditor.Visible = False
        End If
    End Sub

    Private Sub SetParametersFromSelection(ByVal f As Filter)
        Dim p As Parameter

        For x As Integer = 0 To f.Parameters.Count - 1
            p = f.Parameters(x)

            If p.Type = AviSynthType.clip Then
                p.Items.AddRange(GetClips)
            ElseIf p.Type = AviSynthType.bool Then
                p.Items.Add("true")
                p.Items.Add("false")
            ElseIf p.Type = AviSynthType.int Then
                If p.Max - p.Min > 0 Then
                    Dim hotStepper As Double = p.Step
                    If hotStepper = 0 Then
                        hotStepper = 1
                    End If
                    For i As Double = p.Min To p.Max Step hotStepper
                        p.Items.Add(i.ToString())
                    Next
                End If
            ElseIf p.Type = AviSynthType.float Then
                If p.Max - p.Min > 0 Then
                    Dim hotStepper As Double = p.Step
                    If hotStepper = 0 Then
                        hotStepper = 1
                    End If
                    For i As Double = p.Min To p.Max Step hotStepper
                        p.Items.Add(i.ToString(Globalization.NumberFormatInfo.InvariantInfo))
                    Next
                End If
            End If

            p.Value = p.Default
        Next

        Dim s As String = Str.GetLeft(Str.GetRight(rtb.SelectedText, "("), ")")
        Dim arr As String() = Split(s, ",")
        Dim offset As Integer
        If f.Parameters(0).Type = AviSynthType.clip AndAlso _
            f.Parameters(0).Optional Then offset = 1
        If GetClips.IndexOf(GetClips, arr(0)) > -1 Then offset = 0
        If arr(0) <> "" Then
            Dim x As Integer
            For x = 0 To arr.Length - 1
                If Str.Contains(arr(x), "=") Then
                    For i2 As Integer = 0 To f.Parameters.Count - 1
                        p = f.Parameters(i2)
                        If p.Name.ToLower = Str.GetLeft(arr(x), "=").Trim(" "c).ToLower Then
                            p.Value = Str.GetRight(arr(x), "=").Trim(""""c, " "c)
                        End If
                    Next
                Else
                    If x + offset < f.Parameters.Count Then
                        f.Parameters(x + offset).Value = arr(x).Trim(""""c, " "c)
                    End If
                End If
            Next
        End If
    End Sub

    Private Function GetOverloads(ByVal f As Filter) As FilterCollection
        Dim fc As New FilterCollection

        For i As Integer = 0 To g.Filters.Count - 1
            If f.Name.ToLower() = g.Filters(i).Name.ToLower() Then
                fc.Add(g.Filters(i))
            End If
        Next

        Return fc
    End Function

    Private Function GetLastFilter(ByVal filters As FilterCollection) As Filter
        Dim f As Filter = CType(filters(0), Filter)
        If g.Settings.LastOverloadedFilter.ContainsKey(f.Name) Then
            Dim index As Integer = CInt(g.Settings.LastOverloadedFilter(f.Name))
            If index < filters.Count Then
                Return filters(index)
            End If
        End If
        Return filters(0)
    End Function

    Private Function SetParameterGrid() As Boolean
        If rtb.SelectedText <> "" Then
            Dim f As Filter = GetFilterParametersIncluded()
            If Not f Is Nothing Then
                Dim fc As FilterCollection = GetOverloads(f)
                If Not fc Is Nothing AndAlso fc.Count > 0 Then
                    Dim fc2 As New FilterCollection
                    cbGridObjects.Items.Clear()
                    For Each i As Filter In fc
                        i = CType(g.GetRefTypeClone(i), Filter)
                        i.DisplayFullName = True
                        fc2.Add(i)
                        cbGridObjects.Items.Add(i)
                    Next
                    cbGridObjects.SelectedItem = GetLastFilter(fc2)
                    Return True
                End If
            End If
        End If
        cbGridObjects.Items.Clear()
        pgParameters.SelectedObject = Nothing
        Return False
    End Function

    Private Sub cbGridObjects_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbGridObjects.SelectedIndexChanged
        If Not cbGridObjects.SelectedItem Is Nothing Then
            Dim f As Filter = CType(cbGridObjects.SelectedItem, Filter)
            SetParametersFromSelection(f)
            _CurrentFilter = f
            EnableEditorButton(f)
            pgParameters.SelectedObject = New FilterDescriptor(f)

            If cbGridObjects.Items.Count > 1 Then
                g.Settings.LastOverloadedFilter(f.Name) = cbGridObjects.SelectedIndex
            End If
        End If
    End Sub

    Public Class FilterDescriptor
        Implements ICustomTypeDescriptor

        Private _filter As Filter

        Public Property Filter() As Filter
            Get
                Return _filter
            End Get
            Set(ByVal Value As Filter)
                _filter = Value
            End Set
        End Property

        Public Sub New(ByVal f As Filter)
            _filter = f
        End Sub

        Public Function GetAttributes() As System.ComponentModel.AttributeCollection Implements System.ComponentModel.ICustomTypeDescriptor.GetAttributes
            Return TypeDescriptor.GetAttributes(Me, True)
        End Function

        Public Function GetClassName() As String Implements System.ComponentModel.ICustomTypeDescriptor.GetClassName
            Return TypeDescriptor.GetClassName(Me, True)
        End Function

        Public Function GetComponentName() As String Implements System.ComponentModel.ICustomTypeDescriptor.GetComponentName
            Return TypeDescriptor.GetComponentName(Me, True)
        End Function

        Public Function GetConverter() As System.ComponentModel.TypeConverter Implements System.ComponentModel.ICustomTypeDescriptor.GetConverter
            Return TypeDescriptor.GetConverter(Me, True)
        End Function

        Public Function GetDefaultEvent() As System.ComponentModel.EventDescriptor Implements System.ComponentModel.ICustomTypeDescriptor.GetDefaultEvent
            Return TypeDescriptor.GetDefaultEvent(Me, True)
        End Function

        Public Function GetDefaultProperty() As System.ComponentModel.PropertyDescriptor Implements System.ComponentModel.ICustomTypeDescriptor.GetDefaultProperty
            Return TypeDescriptor.GetDefaultProperty(Me, True)
        End Function

        Public Function GetEditor(ByVal editorBaseType As System.Type) As Object Implements System.ComponentModel.ICustomTypeDescriptor.GetEditor
            Return TypeDescriptor.GetEditor(Me, editorBaseType, True)
        End Function

        Public Overloads Function GetEvents() As System.ComponentModel.EventDescriptorCollection Implements System.ComponentModel.ICustomTypeDescriptor.GetEvents
            Return TypeDescriptor.GetEvents(Me, True)
        End Function

        Public Overloads Function GetEvents(ByVal attributes() As System.Attribute) As System.ComponentModel.EventDescriptorCollection Implements System.ComponentModel.ICustomTypeDescriptor.GetEvents
            Return TypeDescriptor.GetEvents(Me, attributes, True)
        End Function

        Public Function GetPropertyOwner(ByVal pd As System.ComponentModel.PropertyDescriptor) As Object Implements System.ComponentModel.ICustomTypeDescriptor.GetPropertyOwner
            Return Me
        End Function

        Public Overloads Function GetProperties(ByVal attributes() As System.Attribute) As System.ComponentModel.PropertyDescriptorCollection Implements System.ComponentModel.ICustomTypeDescriptor.GetProperties
            Dim pds As New PropertyDescriptorCollection(Nothing)

            For Each i As Parameter In _filter.Parameters
                Dim name As String = ""

                If i.Optional Then
                    name = "[" + i.Name + "]"
                Else
                    name = i.Name
                End If

                Dim description As String

                If i.Optional Then
                    description = vbCrLf + "optional " + i.Type.ToString + " " + i.Name
                    If i.Default <> "" Then
                        description += " = " + i.Default
                    End If
                Else
                    description = vbCrLf + i.Type.ToString + " " + i.Name
                End If

                Dim al As New ArrayList

                al.Add(New DefaultValueAttribute(i.Default))
                al.Add(New DescriptionAttribute(description))

                If i.Type = AviSynthType.int AndAlso _
                    Str.Contains(i.Name.ToLower, "color") Then

                    al.Add(New EditorAttribute(GetType(ColorEditor), GetType(UITypeEditor)))
                ElseIf Str.Contains(i.Name.ToLower, "filename") Then
                    al.Add(New EditorAttribute(GetType(SourceFilesEditor), GetType(UITypeEditor)))
                ElseIf i.Items.Count > 0 Then
                    al.Add(New TypeConverterAttribute(GetType(ParameterConverter)))
                End If

                Dim a As Attribute()

                a = CType(al.ToArray(GetType(Attribute)), Attribute())

                pds.Add(New FilterPropertyDescriptor(name, i, a))
            Next

            Return pds
        End Function

        Public Overloads Function GetProperties() As System.ComponentModel.PropertyDescriptorCollection Implements System.ComponentModel.ICustomTypeDescriptor.GetProperties
            Return CType(Me, ICustomTypeDescriptor).GetProperties(New Attribute() {})
        End Function
    End Class

    Public Class FilterPropertyDescriptor
        Inherits PropertyDescriptor

        Private _parameter As Parameter

        Public Property Parameter() As Parameter
            Get
                Return _parameter
            End Get
            Set(ByVal Value As Parameter)
                _parameter = Value
            End Set
        End Property

        Public Sub New(ByVal name As String, ByVal p As Parameter, ByVal a As Attribute())
            MyBase.New(name, a)
            Parameter = p
        End Sub

        Public Overrides Function CanResetValue(ByVal component As Object) As Boolean
            Return Not GetValue(component).Equals(_parameter.Default)
        End Function

        Public Overrides ReadOnly Property ComponentType() As System.Type
            Get
                Return Parameter.GetType()
            End Get
        End Property

        Public Overrides Function GetValue(ByVal component As Object) As Object
            Return Parameter.Value
        End Function

        Public Overrides ReadOnly Property IsReadOnly() As Boolean
            Get
                Return False
            End Get
        End Property

        Public Overrides ReadOnly Property PropertyType() As System.Type
            Get
                Return GetType(String)
            End Get
        End Property

        Public Overrides Sub ResetValue(ByVal component As Object)
            SetValue(Nothing, Parameter.Default)
        End Sub

        Public Overrides Sub SetValue(ByVal component As Object, ByVal value As Object)
            Parameter.Value = CStr(value)
        End Sub

        Public Overrides Function ShouldSerializeValue(ByVal component As Object) As Boolean
            Return Not GetValue(component).Equals(Parameter.Default)
        End Function
    End Class

    Public Class ParameterConverter
        Inherits TypeConverter

        Public Overloads Overrides Function CanConvertTo(ByVal context As ITypeDescriptorContext, ByVal destinationType As Type) As Boolean
            Return MyBase.CanConvertTo(context, destinationType)
        End Function

        Public Overloads Overrides Function ConvertTo(ByVal context As ITypeDescriptorContext, ByVal culture As CultureInfo, ByVal value As Object, ByVal destinationType As Type) As Object
            If destinationType Is GetType(String) Then
                Return CStr(value)
            End If

            Return MyBase.ConvertTo(context, culture, value, destinationType)
        End Function

        Public Overloads Overrides Function CanConvertFrom(ByVal context As System.ComponentModel.ITypeDescriptorContext, ByVal sourceType As System.Type) As Boolean
            If sourceType Is GetType(String) Then
                Return True
            Else
                Return MyBase.CanConvertFrom(context, sourceType)
            End If
        End Function

        Public Overloads Overrides Function ConvertFrom(ByVal context As ITypeDescriptorContext, ByVal culture As CultureInfo, ByVal value As Object) As Object
            If TypeOf value Is String Then
                Return CStr(value)
            End If

            Return MyBase.ConvertFrom(context, culture, value)
        End Function

        Public Overloads Overrides Function GetStandardValuesSupported(ByVal context As ITypeDescriptorContext) As Boolean
            Return True
        End Function

        Public Overloads Overrides Function GetStandardValues(ByVal context As System.ComponentModel.ITypeDescriptorContext) As System.ComponentModel.TypeConverter.StandardValuesCollection
            Dim p As Parameter = CType(g.FormMain.pgParameters.SelectedGridItem.PropertyDescriptor, FilterPropertyDescriptor).Parameter
            Return New StandardValuesCollection(p.Items)
        End Function
    End Class

    Private Sub pgParameters_PropertyValueChanged(ByVal s As Object, ByVal e As System.Windows.Forms.PropertyValueChangedEventArgs) Handles pgParameters.PropertyValueChanged
        Dim fd As FilterDescriptor = CType(pgParameters.SelectedObject, FilterDescriptor)
        For x As Integer = 0 To fd.Filter.Parameters.Count - 1
            _CurrentFilter.Parameters(x) = fd.Filter.Parameters(x)
        Next
        SetTextFromCurrentFilter()
    End Sub

    Public Sub SetTextFromCurrentFilter()
        Dim p As Parameter
        Dim t As String = _CurrentFilter.Name + "("
        Dim value, defaultValue As String
        For x As Integer = 0 To _CurrentFilter.Parameters.Count - 1
            p = _CurrentFilter.Parameters(x)
            value = p.Value
            defaultValue = p.Default
            If p.Type = AviSynthType.string Then
                If Not value.StartsWith("""") Then value = """" + value + """"
                defaultValue = """" + defaultValue + """"
            End If
            If p.Optional And p.Type <> AviSynthType.clip Then
                If defaultValue <> value And value <> "" Then t += p.Name + "=" + value + ","
            Else
                If value <> "" Then t += value + ","
            End If
        Next
        If t.EndsWith(",") Then t = Str.GetLeftLast(t, ",")
        t += ")"
        mBlockRTB_SelectionChanged = True
        RichTextBoxHelper.SetSelectedText(rtb, t)
        mBlockRTB_SelectionChanged = False
    End Sub

    Private Sub miReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miReset.Click
        If Not pgParameters.SelectedObject Is Nothing AndAlso _
            Not pgParameters.SelectedGridItem Is Nothing Then

            pgParameters.ResetSelectedProperty()
            pgParameters_PropertyValueChanged(Nothing, Nothing)
        End If
    End Sub

    Private Sub miParameterHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miParameterHelp.Click
        If Not pgParameters.SelectedObject Is Nothing AndAlso _
            Not pgParameters.SelectedGridItem Is Nothing Then

            Dim p As Parameter = CType(pgParameters.SelectedGridItem.PropertyDescriptor, FilterPropertyDescriptor).Parameter
            Dim t As String

            If p.Optional Then
                t = "optional " + p.Type.ToString + " parameter " + p.Name
                If p.Default <> "" Then
                    t += vbCrLf + "default value: " + p.Default
                End If
                t += vbCrLf + vbCrLf + p.Description
            Else
                t = p.Type.ToString + " parameter " + p.Name + vbCrLf + vbCrLf + p.Description
            End If

            Msg.Show(t, p.Name, MessageBoxIcon.Information)
        End If
    End Sub

    Public Function AddUserFunctions(ByVal s As String) As Boolean
        Dim foundNew As Boolean

        For Each i As Match In Regex.Matches(s, "function (?<1>\w+) ?\((?<2>.+)\)")
            Dim f As New Filter
            Dim pl As New Plugin
            pl.Name = g.GetResource("User")
            f.Plugin = pl
            f.Name = i.Result("${1}")
            f.Category = g.GetResource("User")
            Dim args As String() = Regex.Split(i.Result("${2}"), ",")
            For Each i2 As String In args
                i2 = i2.Trim(" "c)
                For Each i3 As AviSynthType In System.Enum.GetValues(GetType(AviSynthType))
                    If i2.StartsWith(i3.ToString()) Then
                        Dim p As New Parameter
                        p.Name = Str.GetRight(i2, i3.ToString() + " ")
                        p.Type = i3
                        f.Parameters.Add(p)
                    End If
                Next
            Next
            Dim f2 As Filter = g.Filters.GetFilter(f.Name)
            If f2 Is Nothing Then
                foundNew = True
                g.Filters.Add(f)
            End If
        Next

        Return foundNew
    End Function

    Private Sub CheckForUserFunctions()
        Dim foundNew As Boolean

        If str.Contains(rtb.Text, "function") AndAlso str.Contains(rtb.Text, "{") Then
            If AddUserFunctions(rtb.Text) Then
                foundNew = True
            End If
        End If

        If str.Contains(rtb.Text, "Import(") Then
            If Regex.Match(rtb.Text, "Import\("".+""\)").Success Then
                Dim filename As String = Regex.Match(rtb.Text, "Import\(""(?<1>.+)""\)").Result("${1}")
                If Not str.Contains(_AlreadyProcessed, filename) Then
                    If File.Exists(filename) Then
                        Dim str As New Str
                        str.AddFile(filename)
                        If AddUserFunctions(str.Text) Then
                            foundNew = True
                        End If
                        _AlreadyProcessed += filename
                    End If
                End If
            End If
        End If

        If foundNew Then
            PopulateFilterTreeNodes()
            cmTreeView.MenuItems(g.Settings.FilterView).PerformClick()
        End If
    End Sub

    Public Class ColorEditor
        Inherits UITypeEditor

        Public Overloads Overrides Function EditValue(ByVal context As System.ComponentModel.ITypeDescriptorContext, ByVal provider As System.IServiceProvider, ByVal value As Object) As Object
            If TypeOf value Is String Then
                Dim f As New ColorDialog
                Dim s As String = CStr(value)
                s = s.Replace("$", "#")
                Dim cc As New ColorConverter
                f.Color = CType(cc.ConvertFrom(s), Color)
                f.FullOpen = True
                f.ShowDialog()
                Return "$" + f.Color.ToArgb().ToString("x").Substring(2)
            End If

            Return value
        End Function

        Public Overloads Overrides Function GetEditStyle(ByVal context As ITypeDescriptorContext) As UITypeEditorEditStyle
            If Not context Is Nothing And Not context.Instance Is Nothing Then
                Return UITypeEditorEditStyle.Modal
            End If
            Return MyBase.GetEditStyle(context)
        End Function
    End Class

    Public Class SourceFilesEditor
        Inherits UITypeEditor

        Private mSignatur As EditorSignatur

        Public Overloads Overrides Function EditValue(ByVal context As System.ComponentModel.ITypeDescriptorContext, ByVal provider As System.IServiceProvider, ByVal value As Object) As Object
            Dim f As New OpenFileDialog
            f.Multiselect = True
            f.FileName = CStr(value)
            f.ShowDialog()
            If f.FileName <> "" Then
                If f.FileNames.Length > 1 Then
                    Return SplitQuotes(f.FileNames, ",")
                Else
                    Return f.FileName
                End If
            End If
        End Function

        Public Overloads Overrides Function GetEditStyle(ByVal context As ITypeDescriptorContext) As UITypeEditorEditStyle
            If Not context Is Nothing And Not context.Instance Is Nothing Then
                Return UITypeEditorEditStyle.Modal
            End If
            Return MyBase.GetEditStyle(context)
        End Function
    End Class
End Class