Imports System.Text.RegularExpressions

Public Class fPreview
    Inherits System.Windows.Forms.Form
    Public mMovie As New DirectShow.VideoPlayer
    Public mScript As String
    Private mInfo As Boolean
    Public mTrackbar As New fTrackbar(Me)
    Public mRangeStart As Integer = -1
    Private mMain As fMain
    Private mSizeFactor As Double = 1
    Private WithEvents mTimer As New Timer
    Private Shared Event SharedKeyDown(ByVal e As System.Windows.Forms.KeyEventArgs)
    Public Shared Event SharedSetPosInSeconds(ByVal position As Integer)
    Public mTrim As New Hashtable

#Region " Vom Windows Form Designer generierter Code "

    Public Sub New(ByVal script As String)
        MyBase.New()
        InitializeComponent()
        Text = g.GetResource("Preview")
        mScript = script
        Left = 100
        Top = 100
    End Sub

    ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Fr Windows Form-Designer erforderlich
    Private components As System.ComponentModel.IContainer

    'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
    'Sie kann mit dem Windows Form-Designer modifiziert werden.
    'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(fPreview))
        '
        'fPreview
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.Color.Black
        Me.ClientSize = New System.Drawing.Size(74, 16)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.KeyPreview = True
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "fPreview"
        Me.ShowInTaskbar = False
        Me.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide
        Me.StartPosition = System.Windows.Forms.FormStartPosition.Manual
        Me.Text = "Preview"

    End Sub

#End Region

    Private Sub Preview_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        AddHandler SharedKeyDown, AddressOf HandleKeyDown
        AddHandler SharedSetPosInSeconds, AddressOf HandleSetPosInSeconds
        AddHandler g.FormMain.LocationChanged, AddressOf HandleMainLocationChanged

        mTimer.Interval = 1000
        mTimer.Start()
        LoadScript()
        mTrackbar.Height = 10
        AddOwnedForm(mTrackbar)
        Refresh()
        Timer_Tick(Nothing, Nothing)
        If Height > 200 Then
            mTrackbar.Show()
        End If
        Timer_Tick(Nothing, Nothing)
    End Sub

    Public Sub RaiseSetPosInSeconds(ByVal position As Integer)
        RaiseEvent SharedSetPosInSeconds(position)
    End Sub

    Private Sub HandleSetPosInSeconds(ByVal position As Integer)
        mMovie.SetPositionInSeconds(position)
        g.PreviewPosition = mMovie.GetPositionInFrames
        Timer_Tick(Nothing, Nothing)
    End Sub

    Public Sub LoadScript()
        Dim st As New Str(mScript)
        st.Save(Paths.GetApplicationDir + "temp\Preview.avs")
        mMovie.OpenFile(Paths.GetApplicationDir + "temp\Preview.avs")
        Normal()
        mMovie.SetPositionInFrames(g.PreviewPosition)
    End Sub

    Private Sub Full()
        WindowState = FormWindowState.Maximized
        FormBorderStyle = FormBorderStyle.None
        Dim AR As Double = mMovie.GetWidth / mMovie.GetHeight
        If AR > 1.333 Then
            Dim h As Integer = CInt(Width / AR)
            mMovie.SetWindowPosition(Handle, 0, CInt((Height - h) / 2), Width, h)
        Else
            Dim w As Integer = CInt(Height * AR)
            mMovie.SetWindowPosition(Handle, CInt((Width - w) / 2), 0, w, Height)
        End If
    End Sub

    Private Sub Normal()
        Dim h As Integer
        WindowState = FormWindowState.Normal
        FormBorderStyle = FormBorderStyle.FixedSingle
        Width = CInt(mMovie.GetWidth * mSizeFactor)
        Height = CInt(mMovie.GetHeight * mSizeFactor) + 25 + h
        mMovie.SetWindowPosition(Handle, 0, 0, Width, Height - 25 - h)
    End Sub

    Private Sub SwitchWindowState()
        If WindowState = FormWindowState.Normal Then
            Full()
        Else
            Normal()
        End If
    End Sub

    Public Sub Preview_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        RaiseEvent SharedKeyDown(e)
    End Sub

    Private Sub HandleKeyDown(ByVal e As System.Windows.Forms.KeyEventArgs)
        Select Case e.KeyCode
            Case Keys.Space
                mMovie.PlayPause()
            Case Keys.Left
                If e.Alt Then
                    mMovie.StepFrames(-50)
                ElseIf e.Control Then
                    mMovie.SetPositionInFrames(0)
                Else
                    mMovie.StepFrames(-1)
                End If
            Case Keys.Right
                If e.Alt Then
                    mMovie.StepFrames(50)
                ElseIf e.Control Then
                    mMovie.SetPositionInFrames(mMovie.GetFrames - 1)
                Else
                    mMovie.StepFrames(1)
                End If
            Case Keys.Up
                mMovie.StepFrames(-10)
            Case Keys.Down
                mMovie.StepFrames(10)
            Case Keys.PageUp
                mMovie.StepFrames(-100)
            Case Keys.PageDown
                mMovie.StepFrames(100)
            Case Keys.Add
                mMovie.StepFrames(1000)
            Case Keys.Subtract
                mMovie.StepFrames(-1000)
            Case Keys.Oemplus
                mSizeFactor += 0.25
                Normal()
            Case Keys.OemMinus
                mSizeFactor -= 0.25
                Normal()
            Case Keys.Enter
                SwitchWindowState()
            Case Keys.Z
                SwitchWindowState()
            Case Keys.Home
                mRangeStart = mMovie.GetPositionInFrames
            Case Keys.End
                If mRangeStart > -1 Then
                    mTrim(mRangeStart) = mMovie.GetPositionInFrames
                    mRangeStart = -1
                    RichTextBoxHelper.SetSelectedText(g.FormMain.rtb, GetTrim())
                End If
            Case Keys.F5
                Close()
                Exit Sub
            Case Keys.Escape
                Close()
                Exit Sub
            Case Keys.H
                Msg.Show(g.GetResource("ResPreviewKeys"), g.GetResource("Keys"), MessageBoxIcon.Information)
            Case Keys.K
                Msg.Show(g.GetResource("ResPreviewKeys"), g.GetResource("Keys"), MessageBoxIcon.Information)
            Case Keys.Delete
                Dim position As Integer = mMovie.GetPositionInFrames
                Dim hash As Hashtable = CType(mTrim.Clone, Hashtable)
                For Each start As Integer In hash.Keys
                    If start <= position AndAlso CInt(hash(start)) >= position Then
                        mTrim.Remove(start)
                        RichTextBoxHelper.SetSelectedText(g.FormMain.rtb, GetTrim())
                    End If
                Next
            Case Keys.T
                Static Status As Boolean
                Status = Not Status
                If Status Then
                    mTrackbar.Hide()
                Else
                    mTrackbar.Show()
                    Activate()
                End If
        End Select
        g.PreviewPosition = mMovie.GetPositionInFrames
        mTrackbar.UpdateMe(g.PreviewPosition, mRangeStart)
    End Sub

    Public Sub RemoveForm(ByVal f As Form)
        RemoveOwnedForm(f)
    End Sub

    Private Sub Preview_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        g.PreviewPosition = mMovie.GetPositionInFrames
        g.FormMain.Activate()
        RemoveHandler SharedKeyDown, AddressOf HandleKeyDown
        RemoveHandler SharedSetPosInSeconds, AddressOf HandleSetPosInSeconds
        mMovie.Close()
    End Sub

    Public Sub Timer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mTimer.Tick
        mTrackbar.Height = 8
        mTrackbar.Top = Me.Top + Me.Height - 40
        mTrackbar.Left = Me.Left + 20
        mTrackbar.Width = Me.Width - 40
        mTrackbar.UpdateMe(mMovie.GetPositionInFrames, mRangeStart)
    End Sub

    Private Sub Preview_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.LocationChanged
        Timer_Tick(Nothing, Nothing)
    End Sub

    Private Sub HandleMainLocationChanged(ByVal sender As Object, ByVal e As System.EventArgs)
        Try
            If g.FormMain.WindowState = FormWindowState.Minimized Then
                mTrackbar.Hide()
            Else
                mTrackbar.Show()
            End If
        Catch ex As Exception
        End Try
    End Sub

    Private Sub bnPlayPause_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Key(Keys.Space)
    End Sub

    Private Sub Key(ByVal k As Keys)
        Preview_KeyDown(Nothing, New KeyEventArgs(k))
    End Sub

    Private Sub bnForward1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Key(Keys.Right)
    End Sub

    Private Sub bnBack1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Key(Keys.Left)
    End Sub

    Private Sub bnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Key(Keys.Home)
    End Sub

    Private Sub bnEnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Key(Keys.End)
    End Sub

    Private Sub b_Back10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Key(Keys.Up)
    End Sub

    Private Sub b_Forward10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Key(Keys.Down)
    End Sub

    Private Sub bnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Key(Keys.Delete)
    End Sub

    Private Sub bnKeys_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Key(Keys.H)
    End Sub

    Private Sub b_Back100_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Key(Keys.PageUp)
    End Sub

    Private Sub b_Forward100_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Key(Keys.PageDown)
    End Sub

    Private Sub Wheel(ByVal sender As Object, ByVal e As MouseEventArgs) Handles MyBase.MouseWheel
        If e.Delta > 0 Then
            If Control.ModifierKeys = Keys.Alt Then
                mMovie.StepFrames(1000)
            ElseIf Control.ModifierKeys = Keys.Shift Then
                mMovie.StepFrames(100)
            ElseIf Control.ModifierKeys = Keys.Control Then
                mMovie.StepFrames(10)
            Else
                mMovie.StepFrames(1)
            End If
        Else
            If Control.ModifierKeys = Keys.Alt Then
                mMovie.StepFrames(-1000)
            ElseIf Control.ModifierKeys = Keys.Shift Then
                mMovie.StepFrames(-100)
            ElseIf Control.ModifierKeys = Keys.Control Then
                mMovie.StepFrames(-10)
            Else
                mMovie.StepFrames(-1)
            End If
        End If
        Timer_Tick(Nothing, Nothing)
    End Sub

    Public Function GetTrim() As String
        Dim script As String = ""
        Dim list As New ArrayList
        For Each start As Integer In mTrim.Keys
            list.Add(start)
        Next
        list.Sort()
        Dim i As Integer
        For Each start As Integer In list
            If script <> "" Then
                i += 1
                If i Mod 2 = 0 Then
                    script += "+ \" + vbCrLf
                Else
                    script += " + "
                End If
            End If
            script += "Trim(" + start.ToString + "," + CInt(mTrim(start)).ToString + ")"
        Next
        Return script
    End Function

    Private Sub fPreview_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseUp
        If e.Button = MouseButtons.Right Then
            Key(Keys.H)
        End If
    End Sub
End Class