Public Class fTrackbar
    Inherits System.Windows.Forms.Form

    Private mPreview As fPreview
    Private mScript As String

#Region " Vom Windows Form Designer generierter Code "

    Public Sub New(ByVal preview As fPreview)
        MyBase.New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen
        mPreview = preview
    End Sub

    ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Fr Windows Form-Designer erforderlich
    Private components As System.ComponentModel.IContainer

    'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
    'Sie kann mit dem Windows Form-Designer modifiziert werden.
    'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'fTrackbar
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.Color.LightSkyBlue
        Me.ClientSize = New System.Drawing.Size(392, 48)
        Me.Cursor = System.Windows.Forms.Cursors.SizeNS
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None
        Me.Name = "fTrackbar"
        Me.ShowInTaskbar = False
        Me.StartPosition = System.Windows.Forms.FormStartPosition.Manual

    End Sub

#End Region

    Public Sub UpdateMe(ByVal pos As Integer, ByVal rangeStart As Integer)
        Dim st As String
        Refresh()
        Try
            Dim g As Graphics = CreateGraphics()
            For Each start As Integer In mPreview.mTrim.Keys
                g.DrawLine(New Pen(Color.Blue, 20), GetPos(start), 0, GetPos(CInt(mPreview.mTrim(start))), 0)
            Next
            g.DrawLine(New Pen(Color.Yellow, 20), GetPos(pos), 0, GetPos(pos) + 5, 0)
            If rangeStart > -1 And rangeStart <= pos Then g.DrawLine(New Pen(Color.Red, 20), GetPos(rangeStart), 0, GetPos(pos) + 5, 0)
        Catch
        End Try
    End Sub

    Private Function GetPos(ByVal frame As Integer) As Integer
        Return CInt(((Width - 5) / Script.GetFrames(mPreview.mScript)) * frame)
    End Function

    Private Sub fTrackbar_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
        SetPosition()
    End Sub

    Private Sub fTrackbar_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseMove
        If e.Button = MouseButtons.Left Then
            SetPosition()
        End If
    End Sub

    Private Sub SetPosition()
        Owner.Activate()
        mPreview.RaiseSetPosInSeconds(CInt((Script.GetFrames(mPreview.mScript) / Width) * (Control.MousePosition.X - Left) / Script.GetRate(mPreview.mScript)))
    End Sub
End Class
