# AVSEdit build
#####################################################################
# AVSEdit.nsi by jernst
# 
# Output: ../../Builds/AVSEdit<version>.exe
# What it does:
#           1) Extracts AVSEdit files to target directory
#           2) Create shortcuts.exe
#           3) Create uninstaller.exe
#
# Compiled files should be in: ../../bin/
# Before to compile this script, you must compile dotnet.nsi first
#####################################################################
SetCompressor lzma 


!include "MUI.nsh"
!define MUI_LANGUAGE "english"	;Define your own software language
!define PRODUCT "AVSEdit"	;Define your own software name here
!define VERSION "1.0a5" ;Define your own software version here
!define MUI_ICON "..\AviSynth.ico"
!define MUI_UNICON "..\Un_AviSynth.ico"
!define NAME "${PRODUCT} ${VERSION}"
!define MUI_FINISHPAGE_RUN "$INSTDIR\AVSEdit.exe"
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_PAGE_FINISH


Name "${NAME}"

;Language
!insertmacro MUI_LANGUAGE "${MUI_LANGUAGE}"
  
  ;General
  OutFile "..\..\Builds\AVSEdit${VERSION}.exe"
  ShowInstDetails show
  AutoCloseWindow true

  ;Folder-selection page
  InstallDir "$PROGRAMFILES\AVSEdit" ; default
  InstallDirRegKey HKEY_LOCAL_MACHINE "Software\AVSEdit" "InstDir" ; AVSEdit found


;--------------------------------
;Installer Sections

;Installer Sections
Section "" SecCopyUI
  WriteUnInstaller "$INSTDIR\uninstall.exe"
  WriteRegStr HKEY_LOCAL_MACHINE "Software\AVSEdit" "InstDir" "$INSTDIR"
  WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\AVSEdit" "DisplayName" "${NAME}"
  WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\AVSEdit" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\AVSEdit" "NoModify" 1
  WriteRegDWORD HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\AVSEdit" "NoRepair" 1
  WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\AVSEdit" "HelpLink" "http://www.planetdvb.net/"
  WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\AVSEdit" "DisplayIcon" '"$INSTDIR\uninstall.exe"'

  ; AVSEdit
  SetOutPath "$INSTDIR"
  File /r "..\..\bin\*.*"
SectionEnd

Section "Start Menu Shortcuts"
  CreateDirectory "$SMPROGRAMS\AviSynth 2.5"
  CreateShortCut "$SMPROGRAMS\AviSynth 2.5\AVSEdit.lnk" "$INSTDIR\AVSEdit.exe" "" "$INSTDIR\AVSEdit.exe" 0
SectionEnd

Section "End"
  Call IsDotNETInstalled
  Pop $R3
  StrCmp $R3 0 InstallDotNet Dotnetversion
  Dotnetversion:
  	StrCpy $0 0
  	EnumStart:
 	   EnumRegKey $2 HKEY_LOCAL_MACHINE \
      		"Software\Microsoft\.NETFramework\Policy"  $0
    		IntOp $0 $0 + 1
    		StrCmp $2 "" InstallDotNet
    		StrCmp $2 "v1.1" VersionOk EnumStart
  
  InstallDotNet:
  	HideWindow
  	ExecWait $INSTDIR\dotnet.exe
  	Delete $INSTDIR\dotnet.exe
  VersionOk:
SectionEnd

Section Uninstall
SetAutoClose false
    ReadRegStr "$1" HKEY_LOCAL_MACHINE "Software\AVSEdit" "InstDir"
  RMDir /r $1
  DeleteRegKey HKEY_LOCAL_MACHINE "Software\AVSEdit"
  DeleteRegKey HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\AVSEdit"
SectionEnd

  ; IsDotNETInstalled
  ;
  ; Usage:
  ;   Call IsDotNETInstalled
  ;   Pop $0
  ;   StrCmp $0 1 found.NETFramework no.NETFramework
  Function IsDotNETInstalled
  Push $0
  Push $1
  Push $2
  Push $3
  Push $4

  ReadRegStr $4 HKEY_LOCAL_MACHINE \
    "Software\Microsoft\.NETFramework" "InstallRoot"
  # remove trailing back slash
  Push $4
  Exch $EXEDIR
  Exch $EXEDIR
  Pop $4
  # if the root directory doesn't exist .NET is not installed
  IfFileExists $4 0 noDotNET

  StrCpy $0 0

  EnumStart:

    EnumRegKey $2 HKEY_LOCAL_MACHINE \
      "Software\Microsoft\.NETFramework\Policy"  $0
    IntOp $0 $0 + 1
    StrCmp $2 "" noDotNET

    StrCpy $1 0

    EnumPolicy:

      EnumRegValue $3 HKEY_LOCAL_MACHINE \
        "Software\Microsoft\.NETFramework\Policy\$2" $1
      IntOp $1 $1 + 1
       StrCmp $3 "" EnumStart
        IfFileExists "$4\$2.$3" foundDotNET EnumPolicy

  noDotNET:
    StrCpy $0 0
    Goto done

  foundDotNET:
    StrCpy $0 1
    

  done:
    Pop $4
    Pop $3
    Pop $2
    Pop $1
    Exch $0
 FunctionEnd